import { MockFirebaseNamespace } from '@firebase/app-types';
export declare const DEFAULT_ENTRY_NAME = "[DEFAULT]";
/**
 * Through mockers, you can setup the object to state ready for testing and read the object's state directly.
 * Mocker -objects are mixed with the actual mock -objects as a pattern to change mock objects
 * state without any further consequences.
 */
export interface Mocker {
    /**
     * Return object's initial state. You should call this before each firestore test case, to initialize the database state
     */
    reset(): void;
}
/**
 * Return a firebase namespace object.
 *
 * In production, this will be called exactly once and the result
 * assigned to the 'firebase' global.  It may be called multiple times
 * in unit tests.
 */
export declare function createFirebaseNamespace(): MockFirebaseNamespace;
declare type AppError = 'no-app' | 'bad-app-name' | 'duplicate-app' | 'app-deleted' | 'duplicate-service' | 'sa-not-supported' | 'invalid-app-argument';
export declare function error(code: AppError, args?: {
    [name: string]: any;
}): void;
export * from './app';
export * from '../firestore';
export * from '../auth';
export * from '../utils';
