import { ActionCodeSettings, ApplicationVerifier, AuthCredential, AuthProvider, ConfirmationResult, IdTokenResult, MultiFactorUser, User, UserCredential, UserInfo, UserMetadata } from '@firebase/auth-types';
export default class MockUser implements User {
    readonly tenantId: string | null;
    get multiFactor(): MultiFactorUser;
    set multiFactor(value: MultiFactorUser);
    get displayName(): string | null;
    set displayName(value: string | null);
    get email(): string | null;
    set email(value: string | null);
    get isAnonymous(): boolean;
    set isAnonymous(value: boolean);
    get phoneNumber(): string | null;
    set phoneNumber(value: string | null);
    get photoURL(): string | null;
    set photoURL(value: string | null);
    get metadata(): UserMetadata;
    set metadata(value: UserMetadata);
    get refreshToken(): string;
    set refreshToken(value: string);
    get providerId(): string;
    set providerId(value: string);
    get providerData(): Array<UserInfo | null>;
    set providerData(value: Array<UserInfo | null>);
    get uid(): string;
    set uid(value: string);
    get emailVerified(): boolean;
    set emailVerified(value: boolean);
    private _isAnonymous;
    private _metadata;
    private _providerData;
    private _refreshToken;
    private _displayName;
    private _email;
    private _phoneNumber;
    private _photoURL;
    private _providerId;
    private _uid;
    private _emailVerified;
    private _multiFactor;
    constructor();
    delete: () => Promise<void>;
    getIdTokenResult: (forceRefresh?: boolean) => Promise<IdTokenResult>;
    getIdToken: (forceRefresh?: boolean) => Promise<string>;
    /**
     * Links the user account with the given credentials and returns any available additional user information, such as user name.
     *
     * @memberof MockUser
     */
    linkAndRetrieveDataWithCredential: (credential: AuthCredential) => Promise<UserCredential>;
    linkWithCredential: (credential: AuthCredential) => Promise<UserCredential>;
    linkWithPhoneNumber: (phoneNumber: string, applicationVerifier: ApplicationVerifier) => Promise<ConfirmationResult>;
    linkWithPopup: (provider: AuthProvider) => Promise<UserCredential>;
    linkWithRedirect: (provider: AuthProvider) => Promise<void>;
    reauthenticateAndRetrieveDataWithCredential: (credential: AuthCredential) => Promise<UserCredential>;
    reauthenticateWithCredential: (credential: AuthCredential) => Promise<UserCredential>;
    reauthenticateWithPhoneNumber: (phoneNumber: string, applicationVerifier: ApplicationVerifier) => Promise<ConfirmationResult>;
    reauthenticateWithPopup: (provider: AuthProvider) => Promise<UserCredential>;
    reauthenticateWithRedirect: (provider: AuthProvider) => Promise<void>;
    reload: () => Promise<void>;
    sendEmailVerification: (actionCodeSettings?: ActionCodeSettings | null | undefined) => Promise<void>;
    toJSON: () => string;
    unlink: (providerId: string) => Promise<User>;
    updateEmail: (newEmail: string) => Promise<void>;
    updatePassword: (newPassword: string) => Promise<void>;
    updatePhoneNumber: (phoneCredential: AuthCredential) => Promise<void>;
    updateProfile: (profile: {
        displayName?: string | null | undefined;
        photoURL?: string | null | undefined;
    }) => Promise<void>;
    verifyBeforeUpdateEmail: (newEmail: string, actionCodeSettings?: ActionCodeSettings | null | undefined) => Promise<void>;
}
