"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NotImplementedYet_1 = require("../firestore/utils/NotImplementedYet");
var MockMultiFactorUser_1 = require("./MockMultiFactorUser");
var MockUser = /** @class */ (function () {
    function MockUser() {
        this.tenantId = "";
        this._isAnonymous = false;
        this._providerData = [];
        this._refreshToken = '';
        this._displayName = null;
        this._email = null;
        this._phoneNumber = null;
        this._photoURL = null;
        this._providerId = '';
        this._uid = '';
        this._emailVerified = false;
        this._multiFactor = new MockMultiFactorUser_1.MockMultiFactorUser();
        this.delete = function () {
            throw new NotImplementedYet_1.NotImplementedYet('User.delete()');
        };
        this.getIdTokenResult = function (forceRefresh) {
            if (forceRefresh === void 0) { forceRefresh = false; }
            throw new NotImplementedYet_1.NotImplementedYet('User.getIdTokenResult()');
        };
        this.getIdToken = function (forceRefresh) {
            if (forceRefresh === void 0) { forceRefresh = false; }
            throw new NotImplementedYet_1.NotImplementedYet('User.getIdToken()');
        };
        /**
         * Links the user account with the given credentials and returns any available additional user information, such as user name.
         *
         * @memberof MockUser
         */
        this.linkAndRetrieveDataWithCredential = function (credential) {
            throw new NotImplementedYet_1.NotImplementedYet('User.linkAndRetrieveDataWithCredential()');
        };
        this.linkWithCredential = function (credential) {
            throw new NotImplementedYet_1.NotImplementedYet('User.linkWithCredential()');
        };
        this.linkWithPhoneNumber = function (phoneNumber, applicationVerifier) {
            throw new NotImplementedYet_1.NotImplementedYet('User.linkWithPhoneNumber()');
        };
        this.linkWithPopup = function (provider) {
            throw new NotImplementedYet_1.NotImplementedYet('User.linkWithPopup()');
        };
        this.linkWithRedirect = function (provider) {
            throw new NotImplementedYet_1.NotImplementedYet('User.linkWithRedirect()');
        };
        this.reauthenticateAndRetrieveDataWithCredential = function (credential) {
            throw new NotImplementedYet_1.NotImplementedYet('User.reauthenticateAndRetrieveDataWithCredential()');
        };
        this.reauthenticateWithCredential = function (credential) {
            throw new NotImplementedYet_1.NotImplementedYet('User.reauthenticateWithCredential()');
        };
        this.reauthenticateWithPhoneNumber = function (phoneNumber, applicationVerifier) {
            throw new NotImplementedYet_1.NotImplementedYet('User.reauthenticateWithPhoneNumber()');
        };
        this.reauthenticateWithPopup = function (provider) {
            throw new NotImplementedYet_1.NotImplementedYet('User.reauthenticateWithPopup()');
        };
        this.reauthenticateWithRedirect = function (provider) {
            throw new NotImplementedYet_1.NotImplementedYet('User.reauthenticateWithRedirect()');
        };
        this.reload = function () {
            throw new NotImplementedYet_1.NotImplementedYet('User.reload()');
        };
        this.sendEmailVerification = function (actionCodeSettings) {
            throw new NotImplementedYet_1.NotImplementedYet('User.sendEmailVerification()');
        };
        this.toJSON = function () {
            throw new NotImplementedYet_1.NotImplementedYet('User.toJSON()');
        };
        this.unlink = function (providerId) {
            throw new NotImplementedYet_1.NotImplementedYet('User.unlink()');
        };
        this.updateEmail = function (newEmail) {
            throw new NotImplementedYet_1.NotImplementedYet('User.updateEmail()');
        };
        this.updatePassword = function (newPassword) {
            throw new NotImplementedYet_1.NotImplementedYet('User.updatePassword()');
        };
        this.updatePhoneNumber = function (phoneCredential) {
            throw new NotImplementedYet_1.NotImplementedYet('User.updatePhoneNumber()');
        };
        this.updateProfile = function (profile) {
            throw new NotImplementedYet_1.NotImplementedYet('User.updateProfile()');
        };
        this.verifyBeforeUpdateEmail = function (newEmail, actionCodeSettings) {
            throw new NotImplementedYet_1.NotImplementedYet('User.verifyBeforeUpdateEmail()');
        };
        this._metadata = {};
    }
    Object.defineProperty(MockUser.prototype, "multiFactor", {
        get: function () {
            return this._multiFactor;
        },
        set: function (value) {
            this._multiFactor = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "displayName", {
        get: function () {
            return this._displayName;
        },
        set: function (value) {
            this._displayName = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "email", {
        get: function () {
            return this._email;
        },
        set: function (value) {
            this._email = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "isAnonymous", {
        get: function () {
            return this._isAnonymous;
        },
        set: function (value) {
            this._isAnonymous = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "phoneNumber", {
        get: function () {
            return this._phoneNumber;
        },
        set: function (value) {
            this._phoneNumber = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "photoURL", {
        get: function () {
            return this._photoURL;
        },
        set: function (value) {
            this._photoURL = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "metadata", {
        get: function () {
            return this._metadata;
        },
        set: function (value) {
            this._metadata = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "refreshToken", {
        get: function () {
            return this._refreshToken;
        },
        set: function (value) {
            this._refreshToken = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "providerId", {
        get: function () {
            return this._providerId;
        },
        set: function (value) {
            this._providerId = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "providerData", {
        get: function () {
            return this._providerData;
        },
        set: function (value) {
            this._providerData = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "uid", {
        get: function () {
            return this._uid;
        },
        set: function (value) {
            this._uid = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockUser.prototype, "emailVerified", {
        get: function () {
            return this._emailVerified;
        },
        set: function (value) {
            this._emailVerified = value;
        },
        enumerable: true,
        configurable: true
    });
    return MockUser;
}());
exports.default = MockUser;
//# sourceMappingURL=MockUser.js.map