"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var deepCopy_1 = require("../utils/deepCopy");
var MockDocumentReference_1 = require("./MockDocumentReference");
var MockQuery_1 = require("./MockQuery");
var MockQueryDocumentSnapshot_1 = require("./MockQueryDocumentSnapshot");
var MockQuerySnapshot_1 = require("./MockQuerySnapshot");
var utils_1 = require("./utils");
var CallbackHandler_1 = require("./utils/CallbackHandler");
var MockCollectionReference = /** @class */ (function () {
    // tslint:disable-next-line
    function MockCollectionReference(firestore, id, parent) {
        var _this = this;
        if (parent === void 0) { parent = null; }
        this.firestore = firestore;
        this.id = id;
        this.parent = parent;
        this._docRefs = {};
        this._snapshotCallbackHandler = new CallbackHandler_1.default();
        /**
         * Get a `DocumentReference` for the document within the collection at the
         * specified path. If no path is specified, an automatically-generated
         * unique ID will be used for the returned DocumentReference.
         *
         * @param documentPath A slash-separated path to a document.
         * @return The `DocumentReference` instance.
         */
        this.doc = function (documentPath) {
            return utils_1.resolveReference(_this.firestore, _this.parent, false, documentPath || _this.firestore.mocker.getNextDocumentId(_this.path), false, _this);
        };
        /**
         * Add a new document to this collection with the specified data, assigning
         * it a document ID automatically.
         *
         * @param data An Object containing the data for the new document.
         * @return A Promise resolved with a `DocumentReference` pointing to the
         * newly created document after it has been written to the backend.
         */
        this.add = function (data) {
            return new Promise(function (resolve, reject) {
                var id = _this.firestore.mocker.getNextDocumentId(_this.path);
                var document = new MockDocumentReference_1.default(_this.firestore, id, _this);
                _this.mocker.setDoc(document);
                document.mocker.setData(deepCopy_1.deepCopy(data));
                document.fireDocumentChangeEvent('added');
                resolve(document);
            });
        };
        /**
         * Returns true if this `CollectionReference` is equal to the provided one.
         *
         * @param other The `CollectionReference` to compare against.
         * @return true if this `CollectionReference` is equal to the provided one.
         */
        this.isEqual = function (other) {
            return _this === other;
        };
        /**
         * The `Firestore` for the Firestore database (useful for performing
         * transactions, etc.).
         */
        // readonly firestore: FirebaseFirestore;
        /**
         * Creates and returns a new Query with the additional filter that documents
         * must contain the specified field and the value should satisfy the
         * relation constraint provided.
         *
         * @param fieldPath The path to compare
         * @param opStr The operation string (e.g "<", "<=", "==", ">", ">=").
         * @param value The value for comparison
         * @return The created Query.
         */
        this.where = function (fieldPath, opStr, value) {
            return new MockQuery_1.default(_this, _this.getDocs()).where(fieldPath, opStr, value);
        };
        /**
         * Creates and returns a new Query that's additionally sorted by the
         * specified field, optionally in descending order instead of ascending.
         *
         * @param fieldPath The field to sort by.
         * @param directionStr Optional direction to sort by ('asc' or 'desc'). If
         * not specified, order will be ascending.
         * @return The created Query.
         */
        this.orderBy = function (fieldPath, directionStr) {
            return new MockQuery_1.default(_this, _this.getDocs()).orderBy(fieldPath, directionStr);
        };
        /**
         * Creates and returns a new Query that's additionally limited to only
         * return up to the specified number of documents.
         *
         * @param limit The maximum number of items to return.
         * @return The created Query.
         */
        this.limit = function (limit) {
            return new MockQuery_1.default(_this, _this.getDocs()).limit(limit);
        };
        this.limitToLast = function (limit) {
            return new MockQuery_1.default(_this, _this.getDocs()).limitToLast(limit);
        };
        /**
         * Creates and returns a new Query that starts at the provided document
         * (inclusive). The starting position is relative to the order of the query.
         * The document must contain all of the fields provided in the orderBy of
         * this query.
         *
         * @param snapshot The snapshot of the document to start at.
         * @param fieldValues The field values to start this query at, in order
         * @return The created Query.
         */
        // public startAt(snapshot: DocumentSnapshot): Query;
        // public startAt(...fieldValues: any[]): Query  {
        this.startAt = function (args) {
            throw new MockQuery_1.default(_this, _this.getDocs()).startAt(args);
        };
        /**
         * Creates and returns a new Query that starts at the provided fields
         * relative to the order of the query. The order of the field values
         * must match the order of the order by clauses of the query.
         *
         * @param fieldValues The field values to start this query at, in order
         * of the query's order by.
         * @return The created Query.
         */
        /**
         * Creates and returns a new Query that starts after the provided document
         * (exclusive). The starting position is relative to the order of the query.
         * The document must contain all of the fields provided in the orderBy of
         * this query.
         *
         * @param snapshot The snapshot of the document to start after.
         * @return The created Query.
         */
        // public startAfter(...fieldValues: any[]): Query;
        // public startAfter = (snapshot: DocumentSnapshot): Query=> {
        this.startAfter = function (args) {
            throw new MockQuery_1.default(_this, _this.getDocs()).startAfter(args);
        };
        /**
         * Creates and returns a new Query that starts after the provided fields
         * relative to the order of the query. The order of the field values
         * must match the order of the order by clauses of the query.
         *
         * @param fieldValues The field values to start this query after, in order
         * of the query's order by.
         * @return The created Query.
         */
        /**
         * Creates and returns a new Query that ends before the provided document
         * (exclusive). The end position is relative to the order of the query. The
         * document must contain all of the fields provided in the orderBy of this
         * query.
         *
         * @param snapshot The snapshot of the document to end before.
         * @return The created Query.
         */
        // endBefore(snapshot: DocumentSnapshot): Query;
        /**
         * Creates and returns a new Query that ends before the provided fields
         * relative to the order of the query. The order of the field values
         * must match the order of the order by clauses of the query.
         *
         * @param fieldValues The field values to end this query before, in order
         * of the query's order by.
         * @return The created Query.
         */
        // endBefore(...fieldValues: any[]): Query;
        this.endBefore = function (args) {
            throw new MockQuery_1.default(_this, _this.getDocs()).endBefore(args);
        };
        /**
         * Creates and returns a new Query that ends at the provided document
         * (inclusive). The end position is relative to the order of the query. The
         * document must contain all of the fields provided in the orderBy of this
         * query.
         *
         * @param snapshot The snapshot of the document to end at.
         * @return The created Query.
         */
        // endAt(snapshot: DocumentSnapshot): Query;
        /**
         * Creates and returns a new Query that ends at the provided fields
         * relative to the order of the query. The order of the field values
         * must match the order of the order by clauses of the query.
         *
         * @param fieldValues The field values to end this query at, in order
         * of the query's order by.
         * @return The created Query.
         */
        // endAt(...fieldValues: any[]): Query;
        this.endAt = function () {
            var fieldValues = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                fieldValues[_i] = arguments[_i];
            }
            throw new MockQuery_1.default(_this, _this.getDocs()).endAt(fieldValues);
        };
        /**
         * Returns true if this `Query` is equal to the provided one.
         *
         * @param other The `Query` to compare against.
         * @return true if this `Query` is equal to the provided one.
         */
        // public isEqual = (other: Query): boolean => {
        //   throw new Error('Not implemented yet');
        // };
        /**
         * Executes the query and returns the results as a QuerySnapshot.
         *
         * Note: By default, get() attempts to provide up-to-date data when possible
         * by waiting for data from the server, but it may return cached data or fail
         * if you are offline and the server cannot be reached. This behavior can be
         * altered via the `GetOptions` parameter.
         *
         * @param options An object to configure the get behavior.
         * @return A Promise that will be resolved with the results of the Query.
         */
        this.get = function (options) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, Promise.resolve(new MockQuery_1.default(this, this.getDocs()).get())];
                }
                catch (error) {
                    return [2 /*return*/, Promise.reject(error)];
                }
                return [2 /*return*/];
            });
        }); };
        /**
         * Attaches a listener for QuerySnapshot events. You may either pass
         * individual `onNext` and `onError` callbacks or pass a single observer
         * object with `next` and `error` callbacks.
         *
         * NOTE: Although an `onCompletion` callback can be provided, it will
         * never be called because the snapshot stream is never-ending.
         *
         * @param options Options controlling the listen behavior.
         * @param onNext A callback to be called every time a new `QuerySnapshot`
         * is available.
         * @param onError A callback to be called if the listen fails or is
         * cancelled. No further callbacks will occur.
         * @param observer A single object containing `next` and `error` callbacks.
         * @return An unsubscribe function that can be called to cancel
         * the snapshot listener.
         */
        this.onSnapshot = function (optionsOrObserverOrOnNext, observerOrOnNextOrOnError, onErrorOrOnCompletion) {
            if (typeof optionsOrObserverOrOnNext === 'function') {
                var callback_1 = optionsOrObserverOrOnNext;
                var unsubscribe = function () {
                    _this._snapshotCallbackHandler.remove(callback_1);
                };
                _this._snapshotCallbackHandler.add(callback_1);
                // Make the initial call to onSnapshot listener
                var documentChanges = _this.getQueryDocumentSnapshots().map(function (snapshot, newIndex) { return ({
                    type: 'added',
                    doc: snapshot,
                    oldIndex: -1,
                    newIndex: newIndex,
                }); });
                _this.fireBatchDocumentChange(documentChanges);
                return unsubscribe;
            }
            throw new Error('Not implemented yet');
        };
        this.fireBatchDocumentChange = function (documentChanges) {
            var docs = _this.getQueryDocumentSnapshots();
            var querySnapshot = new MockQuerySnapshot_1.default(_this, docs, documentChanges);
            _this._snapshotCallbackHandler.fire(querySnapshot);
        };
        this.withConverter = function (converter) {
            throw new Error('Not implemented yet');
        };
        this.mock = function () {
            return _this;
        };
        this.fireSubDocumentChange = function (type, snapshot, oldIndex) {
            if (oldIndex === void 0) { oldIndex = -1; }
            switch (type) {
                case 'modified':
                    {
                        var docs = _this.getQueryDocumentSnapshots();
                        var index = docs.findIndex(function (doc) { return doc.id === snapshot.id; });
                        var documentChanges = [
                            {
                                type: type,
                                doc: docs[index],
                                oldIndex: index,
                                newIndex: index,
                            },
                        ];
                        var querySnapshot = new MockQuerySnapshot_1.default(_this, docs, documentChanges);
                        _this._snapshotCallbackHandler.fire(querySnapshot);
                    }
                    break;
                case 'added':
                    {
                        var docs = _this.getQueryDocumentSnapshots();
                        var newIndex = docs.findIndex(function (doc) { return doc.id === snapshot.id; });
                        var documentChanges = [
                            {
                                type: type,
                                doc: snapshot,
                                oldIndex: -1,
                                newIndex: newIndex,
                            },
                        ];
                        var querySnapshot = new MockQuerySnapshot_1.default(_this, docs, documentChanges);
                        _this._snapshotCallbackHandler.fire(querySnapshot);
                    }
                    break;
                case 'removed':
                    {
                        var docs = _this.getQueryDocumentSnapshots();
                        var documentChanges = [
                            {
                                type: type,
                                doc: snapshot,
                                oldIndex: oldIndex,
                                newIndex: -1,
                            },
                        ];
                        var querySnapshot = new MockQuerySnapshot_1.default(_this, docs, documentChanges);
                        _this._snapshotCallbackHandler.fire(querySnapshot);
                    }
                    break;
                default:
                    throw new Error("Unexpected change type: " + type);
            }
        };
        this.getQueryDocumentSnapshots = function () {
            var result = [];
            Object.keys(_this._docRefs).forEach(function (key) {
                if (_this._docRefs[key] && _this._docRefs[key].data) {
                    result.push(new MockQueryDocumentSnapshot_1.default(_this._docRefs[key]));
                }
            });
            return result;
        };
        var me = this;
        this.mocker = {
            doc: function (documentId) {
                return me._docRefs[documentId];
            },
            setDoc: function (doc) {
                me._docRefs[doc.id] = doc;
            },
            docRefs: function () {
                return me.getDocs();
            },
            deleteDoc: function (documentId) {
                var index = Object.keys(me._docRefs).indexOf(documentId);
                delete me._docRefs[documentId];
                return index;
            },
            load: function (collection) {
                _this.mocker.reset();
                if (collection.docs) {
                    for (var documentId in collection.docs) {
                        if (collection.docs.hasOwnProperty(documentId)) {
                            var documentData = collection.docs[documentId];
                            var document_1 = new MockDocumentReference_1.default(me.firestore, documentId, me);
                            me.mocker.setDoc(document_1);
                            document_1.mocker.load(documentData);
                        }
                    }
                }
            },
            save: function () {
                var collection = {};
                var docKeys = Object.getOwnPropertyNames(me._docRefs);
                if (docKeys.length > 0) {
                    var docs = (collection.docs = {});
                    for (var _i = 0, docKeys_1 = docKeys; _i < docKeys_1.length; _i++) {
                        var docId = docKeys_1[_i];
                        if (me._docRefs[docId].data) {
                            docs[docId] = me._docRefs[docId].mocker.saveDocument();
                        }
                    }
                }
                return collection;
            },
            getShallowCollection: function () {
                var docs = {};
                var docKeys = Object.getOwnPropertyNames(me._docRefs);
                for (var _i = 0, docKeys_2 = docKeys; _i < docKeys_2.length; _i++) {
                    var docId = docKeys_2[_i];
                    var data = me._docRefs[docId].data;
                    docs[docId] = deepCopy_1.deepCopy(data);
                }
                return docs;
            },
            setShallowCollection: function (docs) {
                _this.mocker.reset();
                for (var documentId in docs) {
                    if (docs.hasOwnProperty(documentId)) {
                        var documentData = docs[documentId];
                        var document_2 = new MockDocumentReference_1.default(me.firestore, documentId, me);
                        me.mocker.setDoc(document_2);
                        document_2.mocker.setData(documentData);
                    }
                }
            },
            reset: function () {
                for (var documentId in me._docRefs) {
                    if (me._docRefs.hasOwnProperty(documentId)) {
                        var doc = me._docRefs[documentId];
                        doc.mocker.reset();
                    }
                }
                me._docRefs = {};
                me._snapshotCallbackHandler.reset();
            },
        };
    }
    Object.defineProperty(MockCollectionReference.prototype, "path", {
        /**
         * A string representing the path of the referenced collection (relative
         * to the root of the database).
         */
        get: function () {
            var _a;
            return ((_a = this.parent) === null || _a === void 0 ? void 0 : _a.id) ? this.parent.path + "/" + this.id : this.id;
        },
        enumerable: true,
        configurable: true
    });
    MockCollectionReference.prototype.getDocs = function () {
        var _this = this;
        return Object.getOwnPropertyNames(this._docRefs).map(function (docId) {
            return _this._docRefs[docId];
        });
    };
    return MockCollectionReference;
}());
exports.MockCollectionReference = MockCollectionReference;
//# sourceMappingURL=MockCollectionReference.js.map