"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var deepCopy_1 = require("../utils/deepCopy");
var MockCollectionReference_1 = require("./MockCollectionReference");
var MockDocumentSnapshot_1 = require("./MockDocumentSnapshot");
var MockFieldPath_1 = require("./MockFieldPath");
var MockFieldValue_1 = require("./MockFieldValue");
var utils_1 = require("./utils");
var CallbackHandler_1 = require("./utils/CallbackHandler");
var manipulation_1 = require("./utils/manipulation");
var NotImplementedYet_1 = require("./utils/NotImplementedYet");
var MESSAGE_NO_ENTRY_TO_UPDATE = 'No entity to update';
var MockDocumentReference = /** @class */ (function () {
    /**
     *
     * @param firestore The `Firestore` for the Firestore database (useful for performing
     * transactions, etc.).
     * @param parent A reference to the Collection to which this DocumentReference belongs.
     */
    // tslint:disable-next-line
    function MockDocumentReference(firestore, id, parent) {
        var _this = this;
        this.firestore = firestore;
        this.id = id;
        this.parent = parent;
        this._collections = {};
        this._snapshotCallbackHandler = new CallbackHandler_1.default();
        /**
         * Gets a `CollectionReference` instance that refers to the collection at
         * the specified path.
         *
         * @param collectionPath A slash-separated path to a collection.
         * @return The `CollectionReference` instance.
         */
        this.collection = function (collectionPath) {
            return utils_1.resolveReference(_this.firestore, _this, true, collectionPath);
        };
        /**
         * Returns true if this `DocumentReference` is equal to the provided one.
         *
         * @param other The `DocumentReference` to compare against.
         * @return true if this `DocumentReference` is equal to the provided one.
         */
        this.isEqual = function (other) {
            return _this === other;
        };
        /**
         * Writes to the document referred to by this `DocumentReference`. If the
         * document does not yet exist, it will be created. If you pass
         * `SetOptions`, the provided data can be merged into an existing document.
         *
         * @param data A map of the fields and values for the document.
         * @param options An object to configure the set behavior.
         * @return A Promise resolved once the data has been successfully written
         * to the backend (Note that it won't resolve while you're offline).
         */
        this.set = function (data, options) { return __awaiter(_this, void 0, void 0, function () {
            var changeType, documentSnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        changeType = this.data ? 'modified' : 'added';
                        return [4 /*yield*/, this._set(data, options)];
                    case 1:
                        _a.sent();
                        documentSnapshot = new MockDocumentSnapshot_1.default(this, this.data);
                        this._snapshotCallbackHandler.fire(documentSnapshot);
                        this.parent.fireSubDocumentChange(changeType, documentSnapshot);
                        return [2 /*return*/];
                }
            });
        }); };
        this.setInTransaction = function (transactioData, setData, options) {
            return options && options.merge
                ? MockFieldValue_1.preprocessData(_this.firestore, __assign(__assign({}, transactioData), setData))
                : MockFieldValue_1.preprocessData(_this.firestore, setData);
        };
        /**
         * Updates fields in the document referred to by this `DocumentReference`.
         * The update will fail if applied to a document that does not exist.
         *
         * @param data An object containing the fields and values with which to
         * update the document. Fields can contain dots to reference nested fields
         * within the document.
         * @return A Promise resolved once the data has been successfully written
         * to the backend (Note that it won't resolve while you're offline).
         */
        this.update = function (
        // tslint:disable-next-line
        data, value) {
            var moreFieldsAndValues = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                moreFieldsAndValues[_i - 2] = arguments[_i];
            }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this._data) {
                                // TODO change to use actual exception
                                throw new utils_1.MockFirebaseValidationError(MESSAGE_NO_ENTRY_TO_UPDATE);
                            }
                            return [4 /*yield*/, this._update(true, data, value, moreFieldsAndValues)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Updates fields in the document referred to by this `DocumentReference`.
         * The update will fail if applied to a document that does not exist.
         *
         * @param data An object containing the fields and values with which to
         * update the document. Fields can contain dots to reference nested fields
         * within the document.
         * @return A Promise resolved once the data has been successfully written
         * to the backend (Note that it won't resolve while you're offline).
         */
        this.updateInTransaction = function (transactionData, data, value) {
            var moreFieldsAndValues = [];
            for (var _i = 3; _i < arguments.length; _i++) {
                moreFieldsAndValues[_i - 3] = arguments[_i];
            }
            if (!transactionData) {
                // TODO change to use actual exception
                throw new Error('No entity to update');
            }
            if (typeof data === 'string' || data instanceof MockFieldPath_1.MockFieldPath) {
                var args = utils_1.parseFieldValuePairsFromArgs([data, value], moreFieldsAndValues);
                return utils_1.setFieldValuePairs(_this.firestore, transactionData, args);
            }
            else {
                // only one parameter, so we treat it as UpdateData
                var args = extractArguments(data);
                return utils_1.setFieldValuePairs(_this.firestore, transactionData, args);
                // return processAndDeepMerge(this.firestore, transactionData, data);
            }
        };
        /**
         * Updates fields in the document referred to by this `DocumentReference`.
         * The update will fail if applied to a document that does not exist.
         *
         * Nested fields can be updated by providing dot-separated field path
         * strings or by providing FieldPath objects.
         *
         * @param field The first field to update.
         * @param value The first value.
         * @param moreFieldsAndValues Additional key value pairs.
         * @return A Promise resolved once the data has been successfully written
         * to the backend (Note that it won't resolve while you're offline).
         */
        // update(field: string | FieldPath, value: any, ...moreFieldsAndValues: any[]): Promise<void>;
        /**
         * Deletes the document referred to by this `DocumentReference`.
         *
         * @return A Promise resolved once the document has been successfully
         * deleted from the backend (Note that it won't resolve while you're
         * offline).
         */
        this.delete = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._delete(true)];
            });
        }); };
        /**
         * Reads the document referred to by this `DocumentReference`.
         *
         * Note: By default, get() attempts to provide up-to-date data when possible
         * by waiting for data from the server, but it may return cached data or fail
         * if you are offline and the server cannot be reached. This behavior can be
         * altered via the `GetOptions` parameter.
         *
         * @param options An object to configure the get behavior.
         * @return A Promise resolved with a DocumentSnapshot containing the
         * current document contents.
         */
        this.get = function (options) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new MockDocumentSnapshot_1.default(this, this.data)];
            });
        }); };
        /**
         * Attaches a listener for DocumentSnapshot events. You may either pass
         * individual `onNext` and `onError` callbacks or pass a single observer
         * object with `next` and `error` callbacks.
         *
         * NOTE: Although an `onCompletion` callback can be provided, it will
         * never be called because the snapshot stream is never-ending.
         *
         * @param options Options controlling the listen behavior.
         * @param onNext A callback to be called every time a new `DocumentSnapshot`
         * is available.
         * @param onError A callback to be called if the listen fails or is
         * cancelled. No further callbacks will occur.
         * @param observer A single object containing `next` and `error` callbacks.
         * @return An unsubscribe function that can be called to cancel
         * the snapshot listener.
         */
        this.onSnapshot = function (nextObservationOrOptions, ObserverErrorOrNext, completeOrError, onComplete) {
            if (typeof nextObservationOrOptions === 'function') {
                var callback_1 = nextObservationOrOptions;
                var unsubscribe = function () {
                    _this._snapshotCallbackHandler.remove(callback_1);
                };
                _this._snapshotCallbackHandler.add(callback_1);
                // Make the initial call to onSnapshot listener
                var snapshot = new MockDocumentSnapshot_1.default(_this, _this.data);
                _this._snapshotCallbackHandler.fire(snapshot, [callback_1]);
                return unsubscribe;
            }
            throw new NotImplementedYet_1.NotImplementedYet('onSnapshot');
        };
        this.withConverter = function (converter) {
            throw new NotImplementedYet_1.NotImplementedYet('withConverter');
        };
        this.fireDocumentChangeEvent = function (changeType, oldIndex, cascade, callbacks) {
            if (oldIndex === void 0) { oldIndex = -1; }
            if (cascade === void 0) { cascade = true; }
            var snapshot = new MockDocumentSnapshot_1.default(_this, _this.data);
            cascade && _this.parent.fireSubDocumentChange(changeType, snapshot, oldIndex);
            _this._snapshotCallbackHandler.fire(snapshot, callbacks);
        };
        this.mock = function () {
            return _this;
        };
        this.commitChange = function (type, value) { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = type;
                        switch (_a) {
                            case 'added': return [3 /*break*/, 1];
                            case 'modified': return [3 /*break*/, 1];
                            case 'removed': return [3 /*break*/, 3];
                        }
                        return [3 /*break*/, 5];
                    case 1: // To make deletation work, we must treat modify as a set of object on commit
                    return [4 /*yield*/, this._set(value)];
                    case 2:
                        _b.sent(); // TODO options
                        return [2 /*return*/, {
                                type: type,
                                doc: new MockDocumentSnapshot_1.default(this, __assign({}, value)),
                                newIndex: -1,
                                oldIndex: -1,
                            }]; // TODO typing
                    case 3: return [4 /*yield*/, this._delete(false)];
                    case 4:
                        _b.sent(); // TODO FIeld paths etc
                        return [2 /*return*/, {
                                type: type,
                                doc: new MockDocumentSnapshot_1.default(this, __assign({}, value)),
                                newIndex: -1,
                                oldIndex: -1,
                            }]; // TODO typing
                    case 5: throw new Error("Unidentified change type " + type + ".");
                }
            });
        }); };
        /**
         * Private set -method used inside and outside of transaction
         *
         * @private
         * @memberof MockDocumentReference
         */
        this._set = function (data, options) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (options && options.merge) {
                    this._data = manipulation_1.processAndDeepMerge(this.firestore, this.data, data);
                }
                else {
                    this._data = MockFieldValue_1.preprocessData(this.firestore, data);
                }
                return [2 /*return*/];
            });
        }); };
        this._update = function (fireCallbacks, data, value) {
            var moreFieldsAndValues = [];
            for (var _i = 3; _i < arguments.length; _i++) {
                moreFieldsAndValues[_i - 3] = arguments[_i];
            }
            return __awaiter(_this, void 0, void 0, function () {
                var args, args;
                return __generator(this, function (_a) {
                    if (!this._data) {
                        // TODO change to use actual exception
                        throw new utils_1.MockFirebaseValidationError(MESSAGE_NO_ENTRY_TO_UPDATE);
                    }
                    if (typeof data === 'string' || data instanceof MockFieldPath_1.MockFieldPath) {
                        args = utils_1.parseFieldValuePairsFromArgs([data, value], moreFieldsAndValues);
                        this._data = utils_1.setFieldValuePairs(this.firestore, this.data, args);
                    }
                    else if (typeof data === 'object') {
                        args = extractArguments(data);
                        this._data = utils_1.setFieldValuePairs(this.firestore, this._data, args);
                    }
                    else {
                        throw new Error('Unsupported data type: ' + typeof data);
                    }
                    fireCallbacks && this.fireDocumentChangeEvent('modified');
                    return [2 /*return*/];
                });
            });
        };
        this._delete = function (fireCallbacks) { return __awaiter(_this, void 0, void 0, function () {
            var callbacks, oldIndex;
            return __generator(this, function (_a) {
                callbacks = this._snapshotCallbackHandler.list;
                oldIndex = this.parent.mocker.deleteDoc(this.id);
                fireCallbacks && this.fireDocumentChangeEvent('removed', oldIndex, true, callbacks);
                // remove data after triggering events
                this._data = undefined;
                this.mocker.reset(); // TODO this must be tested how this will act with a real Firestore. Collections are not removed?
                return [2 /*return*/];
            });
        }); };
        var me = this;
        this.mocker = {
            collection: function (collectionId) {
                return me._collections[collectionId];
            },
            setCollection: function (collection) {
                me._collections[collection.id] = collection;
            },
            getData: function () {
                return me.data ? deepCopy_1.deepCopy(me.data) : undefined;
            },
            setData: function (data) {
                me._data = data;
            },
            reset: function () {
                for (var collectionId in me._collections) {
                    if (_this._collections.hasOwnProperty(collectionId)) {
                        var collection = me._collections[collectionId];
                        collection.mocker.reset();
                    }
                }
                me._collections = {};
                me._snapshotCallbackHandler.reset();
                me._data = undefined;
            },
            load: function (document) {
                me.mocker.reset();
                me._data = deepCopy_1.deepCopy(document.data);
                var collections = document.collections;
                if (collections) {
                    for (var collectionId in collections) {
                        if (collections.hasOwnProperty(collectionId)) {
                            var collectionData = collections[collectionId];
                            var collection = new MockCollectionReference_1.MockCollectionReference(me.firestore, collectionId, me);
                            _this.mocker.setCollection(collection);
                            collection.mocker.load(collectionData);
                        }
                    }
                }
                var listeners = document.listerners;
                if (listeners) {
                    me._snapshotCallbackHandler.load(listeners);
                }
            },
            saveCollections: function () {
                var result = {};
                for (var collectionId in me._collections) {
                    if (me._collections.hasOwnProperty(collectionId)) {
                        var collection = me._collections[collectionId];
                        result[collectionId] = collection.mocker.save();
                    }
                }
                return result;
            },
            saveDocument: function () {
                var result = {
                    data: __assign({}, me.data),
                };
                var collectionKeys = Object.getOwnPropertyNames(me._collections);
                if (collectionKeys.length > 0) {
                    var collections = me.mocker.saveCollections();
                    if (collections) {
                        result.collections = collections;
                    }
                }
                return result;
            },
            listeners: function () {
                return me._snapshotCallbackHandler.list;
            },
        };
    }
    Object.defineProperty(MockDocumentReference.prototype, "path", {
        /**
         * A string representing the path of the referenced document (relative
         * to the root of the database).
         */
        get: function () {
            return this.parent ? this.parent.path + "/" + this.id : this.id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockDocumentReference.prototype, "data", {
        get: function () {
            return deepCopy_1.deepCopy(this._data);
        },
        enumerable: true,
        configurable: true
    });
    return MockDocumentReference;
}());
exports.default = MockDocumentReference;
function extractArguments(data) {
    var args = [];
    var fieldNames = Object.getOwnPropertyNames(data);
    for (var _i = 0, fieldNames_1 = fieldNames; _i < fieldNames_1.length; _i++) {
        var fieldName = fieldNames_1[_i];
        var fieldValue = data[fieldName];
        if (fieldName.includes('.')) {
            var paths = fieldName.split('.');
            args.push(new (MockFieldPath_1.MockFieldPath.bind.apply(MockFieldPath_1.MockFieldPath, __spreadArrays([void 0], paths)))());
        }
        else {
            args.push(fieldName);
        }
        args.push(fieldValue);
    }
    return args;
}
exports.extractArguments = extractArguments;
//# sourceMappingURL=MockDocumentReference.js.map