"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * An immutable object representing a geo point in Firestore. The geo point
 * is represented as latitude/longitude pair.
 *
 * Latitude values are in the range of [-90, 90].
 * Longitude values are in the range of [-180, 180].
 */
var MockGeoPoint = /** @class */ (function () {
    /**
     * Creates a new immutable GeoPoint object with the provided latitude and
     * longitude values.
     * @param latitude The latitude as number between -90 and 90.
     * @param longitude The longitude as number between -180 and 180.
     */
    function MockGeoPoint(latitude, longitude) {
        var _this = this;
        this.latitude = latitude;
        this.longitude = longitude;
        // readonly latitude: number;
        // readonly longitude: number;
        /**
         * Returns true if this `GeoPoint` is equal to the provided one.
         *
         * @param other The `GeoPoint` to compare against.
         * @return true if this `GeoPoint` is equal to the provided one.
         */
        this.isEqual = function (other) {
            return _this.latitude === other.latitude && _this.longitude === other.longitude;
        };
    }
    return MockGeoPoint;
}());
exports.MockGeoPoint = MockGeoPoint;
//# sourceMappingURL=MockGeoPoint.js.map