"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("@firebase/util");
var MockDocumentSnapshot_1 = require("./MockDocumentSnapshot");
var MockFieldPath_1 = require("./MockFieldPath");
var MockFieldValue_1 = require("./MockFieldValue");
var utils_1 = require("./utils");
var NotImplementedYet_1 = require("./utils/NotImplementedYet");
/**
 * A reference to a transaction.
 * The `Transaction` object passed to a transaction's updateFunction provides
 * the methods to read and write data within the transaction context. See
 * `Firestore.runTransaction()`.
 */
var MockTransaction = /** @class */ (function () {
    function MockTransaction(firestore) {
        var _this = this;
        this.firestore = firestore;
        this.transactionData = {};
        this.transactionOperation = {};
        /**
         * True if any of set, update and delete -methods have been called. Firestore do not allow any reading
         * of data after modifications are done. This field is used internally to indicate if these operations
         * have been done.
         *
         * @private
         * @memberof MockTransaction
         */
        this.modified = false;
        /**
         * Reads the document referenced by the provided `DocumentReference.`
         *
         * @param documentRef A reference to the document to be read.
         * @return A DocumentSnapshot for the read data.
         */
        this.get = function (documentRef) { return __awaiter(_this, void 0, void 0, function () {
            var doc, data;
            return __generator(this, function (_a) {
                if (this.modified) {
                    throw new utils_1.MockFirebaseValidationError('Read operations can only be done before write operations.');
                }
                doc = documentRef;
                data = (doc.data ? __assign({}, doc.data) : undefined);
                return [2 /*return*/, new MockDocumentSnapshot_1.default(doc, data)]; // TODO deep copy
            });
        }); };
        /**
         * Writes to the document referred to by the provided `DocumentReference`.
         * If the document does not exist yet, it will be created. If you pass
         * `SetOptions`, the provided data can be merged into the existing document.
         *
         * @param documentRef A reference to the document to be set.
         * @param data An object of the fields and values for the document.
         * @param options An object to configure the set behavior.
         * @return This `Transaction` instance. Used for chaining method calls.
         */
        this.set = function (documentRef, data, options) {
            _this.modified = true;
            var path = documentRef.path;
            var doc = documentRef;
            var docData = _this.transactionData[path] || (doc.data && __assign({}, doc.data)); // TODO need to do locking for transaction
            var changeType = docData ? 'modified' : 'added';
            if (options && options.merge) {
                docData = __assign(__assign({}, docData), data);
                _this.transactionData[path] = doc.updateInTransaction(docData, data);
            }
            else {
                docData = __assign({}, data);
                _this.transactionData[path] = doc.setInTransaction(docData, data, options);
            }
            _this.transactionOperation[path] = changeType;
            return _this;
        };
        /**
         * Updates fields in the document referred to by the provided
         * `DocumentReference`. The update will fail if applied to a document that
         * does not exist.
         *
         * @param documentRef A reference to the document to be updated.
         * @param data An object containing the fields and values with which to
         * @param field The first field to update.
         * @param value The first value.
         * @param moreFieldsAndValues Additional key/value pairs.
         * update the document. Fields can contain dots to reference nested fields
         * within the document.
         * @return This `Transaction` instance. Used for chaining method calls.
         */
        this.update = function (documentRef, dataOrField) {
            var moreFieldsAndValues = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                moreFieldsAndValues[_i - 2] = arguments[_i];
            }
            _this.modified = true;
            var path = documentRef.path;
            var data = _this.transactionData[path] || documentRef.data;
            var newData = util_1.deepCopy(data);
            var fieldType = typeof dataOrField;
            if (fieldType === 'string' || dataOrField instanceof MockFieldPath_1.MockFieldPath) {
                // TODO remove repetative code
                var args = utils_1.parseFieldValuePairsFromArgs([dataOrField], [moreFieldsAndValues]);
                _this.updateFieldsFromArgs(args, data, newData);
                _this.transactionData[path] = newData;
                _this.transactionOperation[path] = 'modified';
                return _this;
            }
            if (typeof dataOrField === 'object') {
                _this.transactionData[path] = documentRef.updateInTransaction(data, dataOrField, moreFieldsAndValues);
                _this.transactionOperation[path] = 'modified';
                return _this;
            }
            throw new NotImplementedYet_1.NotImplementedYet('MockTransaction.get');
        };
        /**
         * Deletes the document referred to by the provided `DocumentReference`.
         *
         * @param documentRef A reference to the document to be deleted.
         * @return This `Transaction` instance. Used for chaining method calls.
         */
        this.delete = function (documentRef) {
            _this.modified = true;
            var path = documentRef.path;
            _this.transactionData[path] = undefined;
            _this.transactionOperation[path] = 'removed';
            return _this;
        };
        this.commit = function () { return __awaiter(_this, void 0, void 0, function () {
            var collectionChanges, _a, _b, _i, path, operation, doc, documentChange, collectionPath, changes, collectionId, documentChanges, documentId, document_1, collection, error_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        collectionChanges = {};
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, , 7]);
                        _a = [];
                        for (_b in this.transactionOperation)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        path = _a[_i];
                        if (!this.transactionOperation.hasOwnProperty(path)) return [3 /*break*/, 4];
                        operation = this.transactionOperation[path];
                        doc = this.firestore.doc(path);
                        return [4 /*yield*/, doc.commitChange(operation, this.transactionData[path])];
                    case 3:
                        documentChange = _c.sent();
                        collectionPath = path.substr(0, path.lastIndexOf('/'));
                        changes = collectionChanges[collectionPath] || [];
                        changes.push(documentChange); // TODO typing
                        collectionChanges[collectionPath] = changes;
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        // iterate snapshot callbacks collections and documents
                        for (collectionId in collectionChanges) {
                            if (collectionChanges.hasOwnProperty(collectionId)) {
                                documentChanges = collectionChanges[collectionId];
                                for (documentId in documentChanges) {
                                    if (documentChanges.hasOwnProperty(documentId)) {
                                        document_1 = documentChanges[documentId];
                                        document_1.doc.ref.fireDocumentChangeEvent(document_1.type, documentChanges[documentId].oldIndex, false);
                                    }
                                }
                                collection = this.firestore.collection(collectionId);
                                collection.fireBatchDocumentChange(documentChanges);
                            }
                        }
                        return [3 /*break*/, 7];
                    case 6:
                        error_1 = _c.sent();
                        this.rollback();
                        throw error_1;
                    case 7: return [2 /*return*/];
                }
            });
        }); };
        this.rollback = function () {
            // tslint:disable-next-line: no-console
            // console.log('rollback');
        };
        this.updateFieldsFromArgs = function (args, data, newData) {
            for (var i = 0; i < args.length; i += 2) {
                var fieldPath = args[i];
                var fieldValue = args[i + 1];
                if (typeof fieldPath === 'string') {
                    if (fieldPath.includes('.')) {
                        var extractedFieldPath = new (MockFieldPath_1.MockFieldPath.bind.apply(MockFieldPath_1.MockFieldPath, __spreadArrays([void 0], fieldPath.split('.'))))();
                        _this.updateSingleFieldPathValue(extractedFieldPath, newData, fieldValue, data);
                    }
                    else {
                        if (fieldValue instanceof MockFieldValue_1.MockFieldValue) {
                            MockFieldValue_1.processFieldValue(_this.firestore, data, newData, fieldPath, fieldValue);
                        }
                        else {
                            newData[fieldPath] = fieldValue;
                        }
                    }
                }
                else if (fieldPath instanceof MockFieldPath_1.MockFieldPath) {
                    _this.updateSingleFieldPathValue(fieldPath, newData, fieldValue, data);
                }
                else {
                    throw new utils_1.MockFirebaseValidationError("Unsupported field path: typeof(" + typeof fieldPath + ": " + fieldPath + ")");
                }
            }
        };
    }
    MockTransaction.prototype.updateSingleFieldPathValue = function (fieldPath, newData, fieldValue, data) {
        var fieldNames = fieldPath.fieldNames;
        var parent = newData;
        for (var j = 1; j < fieldNames.length; j++) {
            parent[fieldNames[j - 1]] = parent = parent[fieldNames[j - 1]] || {};
            if (typeof parent !== 'object') {
                throw new utils_1.MockFirebaseValidationError("Illegal path. Can not add value under field type of " + typeof parent);
            }
        }
        var propPath = fieldNames[fieldNames.length - 1];
        if (fieldValue instanceof MockFieldValue_1.MockFieldValue) {
            MockFieldValue_1.processFieldValue(this.firestore, data, parent, propPath, fieldValue);
        }
        else {
            parent[propPath] = fieldValue;
        }
    };
    return MockTransaction;
}());
exports.default = MockTransaction;
//# sourceMappingURL=MockTransaction.js.map