"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("@firebase/util");
var MockFieldPath_1 = require("./MockFieldPath");
var utils_1 = require("./utils");
var NotImplementedYet_1 = require("./utils/NotImplementedYet");
/**
 * A write batch, used to perform multiple writes as a single atomic unit.
 *
 * A `WriteBatch` object can be acquired by calling `Firestore.batch()`. It
 * provides methods for adding writes to the write batch. None of the
 * writes will be committed (or visible locally) until `WriteBatch.commit()`
 * is called.
 *
 * Unlike transactions, write batches are persisted offline and therefore are
 * preferable when you don't need to condition your writes on read data.
 */
var MockWriteBatch = /** @class */ (function () {
    function MockWriteBatch(firestore) {
        var _this = this;
        this.firestore = firestore;
        this.transactionData = {};
        this.transactionOperation = {};
        /**
         * Commits all of the writes in this write batch as a single atomic unit.
         *
         * @return A Promise resolved once all of the writes in the batch have been
         * successfully written to the backend as an atomic unit. Note that it won't
         * resolve while you're offline.
         */
        this.commit = function () { return __awaiter(_this, void 0, void 0, function () {
            var collectionChanges, triggers, _a, _b, _i, path, operation, doc, documentChange, collectionPath, changes, _loop_1, this_1, collectionId, trigger, error_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        collectionChanges = {};
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, , 7]);
                        triggers = {};
                        _a = [];
                        for (_b in this.transactionOperation)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        path = _a[_i];
                        if (!this.transactionOperation.hasOwnProperty(path)) return [3 /*break*/, 4];
                        operation = this.transactionOperation[path];
                        doc = this.firestore.doc(path);
                        return [4 /*yield*/, doc.commitChange(operation, this.transactionData[path])];
                    case 3:
                        documentChange = _c.sent();
                        collectionPath = path.substr(0, path.lastIndexOf('/'));
                        changes = collectionChanges[collectionPath] || [];
                        changes.push(documentChange); // TODO typing
                        collectionChanges[collectionPath] = changes;
                        _loop_1 = function (collectionId) {
                            if (collectionChanges.hasOwnProperty(collectionId)) {
                                var documentChanges_1 = collectionChanges[collectionId];
                                var _loop_2 = function (documentId) {
                                    if (documentChanges_1.hasOwnProperty(documentId)) {
                                        var document_1 = documentChanges_1[documentId];
                                        triggers[document_1.doc.ref.path] = function () {
                                            return document_1.doc.ref.fireDocumentChangeEvent(document_1.type, documentChanges_1[documentId].oldIndex, false);
                                        };
                                    }
                                };
                                for (var documentId in documentChanges_1) {
                                    _loop_2(documentId);
                                }
                                var collection_1 = this_1.firestore.collection(collectionId);
                                triggers[collectionId] = function () {
                                    collection_1.fireBatchDocumentChange(documentChanges_1);
                                };
                            }
                        };
                        this_1 = this;
                        // iterate snapshot callbacks collections and documents
                        for (collectionId in collectionChanges) {
                            _loop_1(collectionId);
                        }
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        // fire triggers
                        for (trigger in triggers) {
                            if (triggers.hasOwnProperty(trigger)) {
                                triggers.hasOwnProperty(trigger) && triggers[trigger]();
                            }
                        }
                        return [3 /*break*/, 7];
                    case 6:
                        error_1 = _c.sent();
                        this.rollback();
                        throw error_1;
                    case 7: return [2 /*return*/];
                }
            });
        }); };
        this.rollback = function () {
            // tslint:disable-next-line: no-console
            console.error('Rollback not implemented yet');
        };
    }
    /**
     * Writes to the document referred to by the provided `DocumentReference`.
     * If the document does not exist yet, it will be created. If you pass
     * `SetOptions`, the provided data can be merged into the existing document.
     *
     * @param documentRef A reference to the document to be set.
     * @param data An object of the fields and values for the document.
     * @param options An object to configure the set behavior.
     * @return This `WriteBatch` instance. Used for chaining method calls.
     */
    MockWriteBatch.prototype.set = function (documentRef, data, options) {
        var path = documentRef.path;
        var doc = documentRef;
        var docData = this.transactionData[path] || (doc.data && __assign({}, doc.data)); // TODO need to do locking for transaction
        var changeType = docData ? 'modified' : 'added';
        if (options && options.merge) {
            docData = __assign(__assign({}, docData), data);
            this.transactionData[path] = doc.updateInTransaction(docData, data);
        }
        else {
            docData = __assign({}, data);
            this.transactionData[path] = doc.setInTransaction(docData, data, options);
        }
        this.transactionOperation[path] = changeType;
        return this;
    };
    /**
     * Updates fields in the document referred to by the provided
     * `DocumentReference`. The update will fail if applied to a document that
     * does not exist.
     *
     * @param documentRef A reference to the document to be updated.
     * @param data An object containing the fields and values with which to
     * update the document. Fields can contain dots to reference nested fields
     * within the document.
     * @return This `WriteBatch` instance. Used for chaining method calls.
     */
    MockWriteBatch.prototype.update = function (documentRef, dataOrField, value) {
        var moreFieldsAndValues = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            moreFieldsAndValues[_i - 3] = arguments[_i];
        }
        var path = documentRef.path;
        var doc = documentRef;
        var data = this.transactionData[path] || util_1.deepCopy(doc.data);
        var fieldType = typeof dataOrField;
        if (fieldType === 'string' || dataOrField instanceof MockFieldPath_1.MockFieldPath) {
            // TODO remove repetative code
            var args = utils_1.parseFieldValuePairsFromArgs([dataOrField, value], moreFieldsAndValues[0]);
            this.transactionData[path] = utils_1.setFieldValuePairs(this.firestore, data, args);
            this.transactionOperation[path] = 'modified';
            return this;
        }
        if (typeof dataOrField === 'object') {
            this.transactionData[path] = documentRef.updateInTransaction(data, dataOrField, value, moreFieldsAndValues);
            this.transactionOperation[path] = 'modified';
            return this;
        }
        throw new NotImplementedYet_1.NotImplementedYet('MockTransaction.get');
    };
    /**
     * Deletes the document referred to by the provided `DocumentReference`.
     *
     * @param documentRef A reference to the document to be deleted.
     * @return This `WriteBatch` instance. Used for chaining method calls.
     */
    MockWriteBatch.prototype.delete = function (documentRef) {
        var path = documentRef.path;
        this.transactionData[path] = undefined;
        this.transactionOperation[path] = 'removed';
        return this;
    };
    return MockWriteBatch;
}());
exports.MockWriteBatch = MockWriteBatch;
//# sourceMappingURL=MockWritebatch.js.map