"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var MockCollectionReference_1 = require("../MockCollectionReference");
var MockDocumentReference_1 = require("../MockDocumentReference");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
/* tslint:disable:no-big-function no-identical-functions */
describe('CollectionReferenceMock', function () {
    describe('References', function () {
        it('doc() returns a document by id', function () {
            var collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
            firestore.mocker.reset();
            firestore.mocker.setCollection(collection);
            var document = new MockDocumentReference_1.default(firestore, 'doc', collection);
            collection.mocker.setDoc(document);
            expect(collection.doc('doc')).toBe(document);
        });
        it('doc() call without an id will return document reference with autogenerated id', function () {
            var collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
            firestore.mocker.reset();
            firestore.mocker.setCollection(collection);
            var document = new MockDocumentReference_1.default(firestore, 'doc', collection);
            collection.mocker.setDoc(document);
            expect(collection.doc().id).toBeDefined();
        });
    });
    describe('add()', function () {
        it('will create a new document with a generated id', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, data, document;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, collection.add(data)];
                    case 1:
                        document = _a.sent();
                        expect(document).toBeDefined();
                        expect(document.id).toBeDefined();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    var testData = {
        list: {
            docs: {
                c: {
                    data: { name: 'c' },
                },
                b: {
                    data: { name: 'b' },
                },
                a: {
                    data: { name: 'a' },
                },
            },
        },
    };
    var testData2 = {
        list: {
            docs: {
                a: {
                    data: { name: 'a' },
                },
                b: {
                    data: { name: 'b', key: 'm' },
                },
                c: {
                    data: { name: 'c', key: 'm' },
                },
                d: {
                    data: { name: 'b' },
                },
            },
        },
    };
    var testDataSub = {
        list: {
            docs: {
                a: {
                    data: {
                        sub: {
                            name: 'a',
                        },
                    },
                },
                b: {
                    data: {
                        sub: {
                            name: 'd',
                            key: 'm',
                        },
                    },
                },
                c: {
                    data: {
                        sub: {
                            name: 'c',
                            key: 'm',
                        },
                    },
                },
                d: {
                    data: {
                        sub: {
                            name: 'b',
                        },
                    },
                },
            },
        },
    };
    describe('get()', function () {
        it('will get all documents', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore.collection('list').get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(3);
                        expect(query.docs[0].data()).toEqual({
                            name: 'c',
                        });
                        expect(query.docs[2].data()).toEqual({
                            name: 'a',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('limit()', function () {
        it('will return max number of documents defined by limit', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore
                                .collection('list')
                                .orderBy('name')
                                .limit(2)
                                .get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(2);
                        expect(query.docs[0].data()).toEqual({
                            name: 'a',
                        });
                        expect(query.docs[1].data()).toEqual({
                            name: 'b',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will give an error if limit is zero or negative', function () {
            firestore.mocker.fromMockDatabase(testData);
            expect(function () {
                return firestore
                    .collection('list')
                    .orderBy('name')
                    .limit(-2);
            }).toThrow();
            expect(function () {
                return firestore
                    .collection('list')
                    .orderBy('name')
                    .limit(0);
            }).toThrow();
        });
    });
    describe('orderBy()', function () {
        it('will return documents in ascending order as default', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore
                                .collection('list')
                                .orderBy('name')
                                .get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(3);
                        expect(query.docs[0].data()).toEqual({
                            name: 'a',
                        });
                        expect(query.docs[1].data()).toEqual({
                            name: 'b',
                        });
                        expect(query.docs[2].data()).toEqual({
                            name: 'c',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will return documents in ascending order as explicitly', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore
                                .collection('list')
                                .orderBy('name', 'asc')
                                .get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(3);
                        expect(query.docs[0].data()).toEqual({
                            name: 'a',
                        });
                        expect(query.docs[1].data()).toEqual({
                            name: 'b',
                        });
                        expect(query.docs[2].data()).toEqual({
                            name: 'c',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        /* tslint:disable:no-identical-functions */
        it('will return documents in descending order explicitly', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore
                                .collection('list')
                                .orderBy('name', 'desc')
                                .get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(3);
                        expect(query.docs[0].data()).toEqual({
                            name: 'c',
                        });
                        expect(query.docs[1].data()).toEqual({
                            name: 'b',
                        });
                        expect(query.docs[2].data()).toEqual({
                            name: 'a',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will return documents in descending order explicitly', function () { return __awaiter(void 0, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testData);
                        return [4 /*yield*/, firestore
                                .collection('list')
                                .orderBy('name', 'desc')
                                .get()];
                    case 1:
                        query = _a.sent();
                        expect(query).toBeDefined();
                        expect(query.size).toBe(3);
                        expect(query.docs[0].data()).toEqual({
                            name: 'c',
                        });
                        expect(query.docs[1].data()).toEqual({
                            name: 'b',
                        });
                        expect(query.docs[2].data()).toEqual({
                            name: 'a',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        // TODO ordering by multiple fields
    });
    describe('where()', function () {
        describe('equality', function () {
            it('will return fields with a equal match', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData2);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('key', '==', 'm')
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                name: 'b',
                                key: 'm',
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'c',
                                key: 'm',
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('sub fields', function () {
            it('will return fields with a equal match', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref, query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testDataSub);
                            ref = firestore
                                .collection('list')
                                .where('sub.key', '==', 'm')
                                .orderBy('sub.name');
                            return [4 /*yield*/, ref.get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                sub: { name: 'c', key: 'm' },
                            });
                            expect(query.docs[1].data()).toEqual({
                                sub: { name: 'd', key: 'm' },
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('comparization', function () {
            var testData3 = {
                list: {
                    docs: {
                        a: {
                            data: {
                                name: 'a',
                                value: 5,
                            },
                        },
                        b: {
                            data: {
                                name: 'b',
                                value: 2,
                            },
                        },
                        c: {
                            data: {
                                name: 'c',
                                value: 10,
                            },
                        },
                        d: {
                            data: {
                                name: 'd',
                                value: 20,
                            },
                        },
                    },
                },
            };
            it('will return fields with less than', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData3);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('value', '<', 10)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                name: 'a',
                                value: 5,
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'b',
                                value: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will return fields with less or equal', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData3);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('value', '<=', 10)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(3);
                            expect(query.docs[0].data()).toEqual({
                                name: 'a',
                                value: 5,
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'b',
                                value: 2,
                            });
                            expect(query.docs[2].data()).toEqual({
                                name: 'c',
                                value: 10,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will return fields greater than', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData3);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('value', '>', 10)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(1);
                            expect(query.docs[0].data()).toEqual({
                                name: 'd',
                                value: 20,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will return fields greater or equal', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData3);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('value', '>=', 10)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                name: 'c',
                                value: 10,
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'd',
                                value: 20,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will return fields between', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData3);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('value', '>=', 5)
                                    .where('value', '<', 15)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                name: 'a',
                                value: 5,
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'c',
                                value: 10,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('array checks', function () {
            var testData4 = {
                list: {
                    docs: {
                        a: {
                            data: {
                                name: 'a',
                                values: [2, 5, 6],
                            },
                        },
                        b: {
                            data: {
                                name: 'b',
                                values: [2, 1, 7],
                            },
                        },
                        c: {
                            data: {
                                name: 'c',
                                values: [1, 5, 8],
                            },
                        },
                    },
                },
            };
            it('is in array match', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData4);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('values', 'array-contains', 5)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(2);
                            expect(query.docs[0].data()).toEqual({
                                name: 'a',
                                values: [2, 5, 6],
                            });
                            expect(query.docs[1].data()).toEqual({
                                name: 'c',
                                values: [1, 5, 8],
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('is not in array match', function () { return __awaiter(void 0, void 0, void 0, function () {
                var query;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(testData4);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .where('values', 'array-contains', 55)
                                    .get()];
                        case 1:
                            query = _a.sent();
                            expect(query).toBeDefined();
                            expect(query.size).toBe(0);
                            return [2 /*return*/];
                    }
                });
            }); });
            // TODO make it work
            // it('will throw error when matching non array field', () => {
            //   firestore.mocker.fromMockDatabase(testData4);
            //   // tslint:disable-next-line: no-floating-promises
            //   expect(() =>
            //     firestore
            //       .collection('list')
            //       .where('name', 'array-contains', 2)
            //       .get()
            //   ).toThrow();
            // });
        });
        describe('paging with a simple fields', function () {
            var database = {
                list: {
                    docs: {
                        a: {
                            data: {
                                name: 'Blueberry',
                                value: 1,
                            },
                        },
                        b: {
                            data: {
                                name: 'Strowberry',
                                value: 2,
                            },
                        },
                        c: {
                            data: {
                                name: 'Rasberry',
                                value: 3,
                            },
                        },
                        d: {
                            data: {
                                name: 'Cloudberry',
                                value: 4,
                            },
                        },
                        e: {
                            data: {
                                name: 'Lingonberry',
                                value: 4,
                            },
                        },
                    },
                },
            };
            it('will limit the result to startAt cursor', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .orderBy('value')
                                    .startAt(3)
                                    .get()];
                        case 1:
                            result = _a.sent();
                            expect(result.size).toBe(3);
                            expect(result.docs[0].data()).toEqual({
                                name: 'Rasberry',
                                value: 3,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will limit the result to startAfter cursor', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .orderBy('value')
                                    .startAfter(2)
                                    .get()];
                        case 1:
                            result = _a.sent();
                            expect(result.size).toBe(3);
                            expect(result.docs[0].data()).toEqual({
                                name: 'Rasberry',
                                value: 3,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will limit the result to endBefore cursor', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .orderBy('value')
                                    .endBefore(3)
                                    .get()];
                        case 1:
                            result = _a.sent();
                            expect(result.size).toBe(2);
                            expect(result.docs[0].data()).toEqual({
                                name: 'Blueberry',
                                value: 1,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will limit the result to endAt cursor', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .orderBy('value')
                                    .endAt(3)
                                    .get()];
                        case 1:
                            result = _a.sent();
                            expect(result.size).toBe(3);
                            expect(result.docs[0].data()).toEqual({
                                name: 'Blueberry',
                                value: 1,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will limit the result between set start and end cursor', function () { return __awaiter(void 0, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            return [4 /*yield*/, firestore
                                    .collection('list')
                                    .orderBy('value')
                                    .startAfter(1)
                                    .endAt(3)
                                    .get()];
                        case 1:
                            result = _a.sent();
                            expect(result.size).toBe(2);
                            expect(result.docs[0].data()).toEqual({
                                name: 'Strowberry',
                                value: 2,
                            });
                            expect(result.docs[1].data()).toEqual({
                                name: 'Rasberry',
                                value: 3,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
    describe('Mocker', function () {
        it('shallow set documents with with shallow set and read them with shallow get', function () {
            var collection = firestore.collection('company');
            collection.mocker.setShallowCollection({
                first: {
                    value: 1,
                },
                second: {
                    value: 2,
                },
            });
            expect(collection.mocker.getShallowCollection()).toEqual({
                first: {
                    value: 1,
                },
                second: {
                    value: 2,
                },
            });
        });
        it('shallow set create ', function () {
            var collection = firestore.collection('company');
            collection.mocker.setShallowCollection({
                first: {
                    value: 1,
                },
                second: {
                    value: 2,
                },
            });
            expect(collection.mocker.getShallowCollection()).toEqual({
                first: {
                    value: 1,
                },
                second: {
                    value: 2,
                },
            });
        });
        it('save set documents ', function () {
            var collection = firestore.collection('company');
            var mock = {
                docs: {
                    first: {
                        data: { value: 1 },
                    },
                    second: {
                        data: { value: 2 },
                    },
                },
            };
            collection.mocker.load(mock);
            expect(collection.mocker.save()).toEqual(mock);
        });
    });
    describe('onSnapshot()', function () {
        it('will trigger once snapshot listener after registration', function () {
            firestore.mocker.reset();
            var collection = firestore.collection('collection');
            var listener = jest.fn();
            collection.onSnapshot(listener);
            expect(listener).toBeCalledTimes(1);
        });
    });
});
//# sourceMappingURL=MockCollectionReference.spec.js.map