"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
// tslint:disable: no-identical-functions
// tslint:disable: no-big-function
describe('Database state restoring', function () {
    describe('Reading the whole database state', function () {
        it('will create the database from an object model', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dogWhisper, database, snap, doc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dogWhisper = function (snapshot) {
                            // tslint:disable-next-line: no-console
                            console.log(snapshot);
                        };
                        database = {
                            animals: {
                                docs: {
                                    cat: {
                                        data: {
                                            name: 'Fluffy',
                                        },
                                        collections: {
                                            foods: {
                                                docs: {
                                                    kitekat: {
                                                        data: {
                                                            quantity: 2,
                                                        },
                                                    },
                                                },
                                            },
                                            photos: {
                                                docs: {
                                                    kitten: {
                                                        data: {
                                                            // tslint:disable-next-line: no-duplicate-string
                                                            photoUrl: 'https://www.cat.com/',
                                                        },
                                                    },
                                                },
                                            },
                                        },
                                    },
                                    dog: {
                                        data: {
                                            // tslint:disable-next-line: no-duplicate-string
                                            name: "Santa's little helper",
                                        },
                                        listerners: [dogWhisper],
                                    },
                                },
                            },
                        };
                        firestore.mocker.fromMockDatabase(database);
                        expect(firestore.doc('animals/dog')).toBeDefined();
                        return [4 /*yield*/, firestore.doc('animals/dog').get()];
                    case 1:
                        snap = _a.sent();
                        expect(snap.exists).toBeTruthy();
                        expect(snap.data()).toEqual({
                            name: "Santa's little helper",
                        });
                        expect(firestore.doc('animals/cat/foods/kitekat')).toBeDefined();
                        return [4 /*yield*/, firestore.doc('animals/cat/foods/kitekat').get()];
                    case 2:
                        snap = _a.sent();
                        expect(snap.exists).toBeTruthy();
                        expect(snap.data()).toEqual({
                            quantity: 2,
                        });
                        doc = firestore.doc('animals/dog');
                        expect(doc.mocker.listeners().length).toBe(1);
                        expect(doc.mocker.listeners()[0]).toBe(dogWhisper);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will load the database state from a json string', function () { return __awaiter(void 0, void 0, void 0, function () {
            var database, result;
            return __generator(this, function (_a) {
                database = {
                    animals: {
                        docs: {
                            cat: {
                                data: {
                                    name: 'Fluffy',
                                },
                                collections: {
                                    foods: {
                                        docs: {
                                            kitekat: {
                                                data: {
                                                    quantity: 2,
                                                },
                                            },
                                        },
                                    },
                                    photos: {
                                        docs: {
                                            kitten: {
                                                data: {
                                                    photoUrl: 'https://www.cat.com/',
                                                },
                                            },
                                        },
                                    },
                                },
                            },
                            dog: {
                                data: {
                                    name: "Santa's little helper",
                                },
                            },
                        },
                    },
                };
                firestore.mocker.fromJson(JSON.stringify(database));
                result = firestore.mocker.toJson();
                expect(result).toMatch(JSON.stringify(database, undefined, 2));
                return [2 /*return*/];
            });
        }); });
    });
    describe('Saving the whole database state', function () {
        it('will save the database state to an object model', function () { return __awaiter(void 0, void 0, void 0, function () {
            var dogWhisper, database, storedDatabase, result;
            return __generator(this, function (_a) {
                dogWhisper = function (snapshot) {
                    console.log(snapshot);
                };
                database = {
                    animals: {
                        docs: {
                            cat: {
                                data: {
                                    name: 'Fluffy',
                                },
                                collections: {
                                    foods: {
                                        docs: {
                                            kitekat: {
                                                data: {
                                                    quantity: 2,
                                                },
                                            },
                                        },
                                    },
                                    photos: {
                                        docs: {
                                            kitten: {
                                                data: {
                                                    photoUrl: 'https://www.cat.com/',
                                                },
                                            },
                                        },
                                    },
                                },
                            },
                            dog: {
                                data: {
                                    name: "Santa's little helper",
                                },
                                listerners: [dogWhisper],
                            },
                        },
                    },
                };
                storedDatabase = {
                    animals: {
                        docs: {
                            cat: {
                                data: {
                                    name: 'Fluffy',
                                },
                                collections: {
                                    foods: {
                                        docs: {
                                            kitekat: {
                                                data: {
                                                    quantity: 2,
                                                },
                                            },
                                        },
                                    },
                                    photos: {
                                        docs: {
                                            kitten: {
                                                data: {
                                                    photoUrl: 'https://www.cat.com/',
                                                },
                                            },
                                        },
                                    },
                                },
                            },
                            dog: {
                                data: {
                                    name: "Santa's little helper",
                                },
                            },
                        },
                    },
                };
                firestore.mocker.fromMockDatabase(database);
                result = firestore.mocker.toMockDatabase();
                expect(result).toEqual(storedDatabase);
                return [2 /*return*/];
            });
        }); });
        it('will save the database state into to a json string', function () { return __awaiter(void 0, void 0, void 0, function () {
            var database, result;
            return __generator(this, function (_a) {
                database = {
                    animals: {
                        docs: {
                            cat: {
                                data: {
                                    name: 'Fluffy',
                                },
                                collections: {
                                    foods: {
                                        docs: {
                                            kitekat: {
                                                data: {
                                                    quantity: 2,
                                                },
                                            },
                                        },
                                    },
                                    photos: {
                                        docs: {
                                            kitten: {
                                                data: {
                                                    photoUrl: 'https://www.cat.com/',
                                                },
                                            },
                                        },
                                    },
                                },
                            },
                            dog: {
                                data: {
                                    name: "Santa's little helper",
                                },
                            },
                        },
                    },
                };
                firestore.mocker.fromMockDatabase(database);
                result = firestore.mocker.toJson();
                expect(result).toMatch(JSON.stringify(database, undefined, 2));
                return [2 /*return*/];
            });
        }); });
    });
    describe('Setting database state by pointing data to paths', function () {
        describe('Collection paths', function () {
            it('Will save documents on the collection in root level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1, doc2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            firestore.mocker.loadCollection('test', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            testRef = firestore.collection('test');
                            return [4 /*yield*/, testRef.doc('doc1').get()];
                        case 1:
                            doc1 = _a.sent();
                            return [4 /*yield*/, testRef.doc('doc2').get()];
                        case 2:
                            doc2 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc2).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2.data()).toEqual({
                                value: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('Will save documents on the collection in sub path level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1, doc2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            // tslint:disable-next-line: no-duplicate-string
                            firestore.mocker.loadCollection('test/doc/sub', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            testRef = firestore.collection('test/doc/sub');
                            return [4 /*yield*/, testRef.doc('doc1').get()];
                        case 1:
                            doc1 = _a.sent();
                            return [4 /*yield*/, testRef.doc('doc2').get()];
                        case 2:
                            doc2 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc2).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2.data()).toEqual({
                                value: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('Will save multiple collections in diffent paths', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1, doc2, test2Ref, doc2_1, doc2_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            firestore.mocker.loadCollection('test/doc/sub', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            firestore.mocker.loadCollection('test2', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            testRef = firestore.collection('test/doc/sub');
                            return [4 /*yield*/, testRef.doc('doc1').get()];
                        case 1:
                            doc1 = _a.sent();
                            return [4 /*yield*/, testRef.doc('doc2').get()];
                        case 2:
                            doc2 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc2).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2.data()).toEqual({
                                value: 2,
                            });
                            test2Ref = firestore.collection('test2');
                            return [4 /*yield*/, test2Ref.doc('doc1').get()];
                        case 3:
                            doc2_1 = _a.sent();
                            return [4 /*yield*/, test2Ref.doc('doc2').get()];
                        case 4:
                            doc2_2 = _a.sent();
                            expect(doc2_1).toBeDefined();
                            expect(doc2_2).toBeDefined();
                            expect(doc2_1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2_2.data()).toEqual({
                                value: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('Will save multiple collections in diffent paths that intersect', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1, doc2, test2Ref, doc2_1, doc2_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            firestore.mocker.loadCollection('test', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            firestore.mocker.loadCollection('test/doc/sub', {
                                doc1: {
                                    value: 1,
                                },
                                doc2: {
                                    value: 2,
                                },
                            });
                            testRef = firestore.collection('test/doc/sub');
                            return [4 /*yield*/, testRef.doc('doc1').get()];
                        case 1:
                            doc1 = _a.sent();
                            return [4 /*yield*/, testRef.doc('doc2').get()];
                        case 2:
                            doc2 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc2).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2.data()).toEqual({
                                value: 2,
                            });
                            test2Ref = firestore.collection('test');
                            return [4 /*yield*/, test2Ref.doc('doc1').get()];
                        case 3:
                            doc2_1 = _a.sent();
                            return [4 /*yield*/, test2Ref.doc('doc2').get()];
                        case 4:
                            doc2_2 = _a.sent();
                            expect(doc2_1).toBeDefined();
                            expect(doc2_2).toBeDefined();
                            expect(doc2_1.data()).toEqual({
                                value: 1,
                            });
                            expect(doc2_2.data()).toEqual({
                                value: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('Document paths', function () {
            it('Will save document on the collection at root level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            firestore.mocker.loadDocument('test/doc1', {
                                value: 1,
                            });
                            testRef = firestore.doc('test/doc1');
                            return [4 /*yield*/, testRef.get()];
                        case 1:
                            doc1 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            // tslint:disable-next-line
            it('Will save document on the collection into a sub path', function () { return __awaiter(void 0, void 0, void 0, function () {
                var testRef, doc1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.reset();
                            firestore.mocker.loadDocument('test/subdoc/subcollection/doc1', {
                                value: 1,
                            });
                            testRef = firestore.doc('test/subdoc/subcollection/doc1');
                            return [4 /*yield*/, testRef.get()];
                        case 1:
                            doc1 = _a.sent();
                            expect(doc1).toBeDefined();
                            expect(doc1.data()).toEqual({
                                value: 1,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
//# sourceMappingURL=MockDatabase.spec.js.map