"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var MockCollectionReference_1 = require("../MockCollectionReference");
var MockDocumentReference_1 = require("../MockDocumentReference");
var MockFieldPath_1 = require("../MockFieldPath");
var documentPath = 'company/mindhive/skills/coding/technologies';
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
/* tslint:disable:no-big-function no-identical-functions */
describe('DocumentReferenceMock', function () {
    describe('Paths', function () {
        it('Will return a path to a document', function () {
            var document = firestore.collection('company').doc('mindhive');
            expect(document.path).toMatch('company/mindhive');
        });
        it('Will return a path to a collection', function () {
            var collection = firestore.collection(documentPath);
            expect(collection.path).toMatch(documentPath);
        });
    });
    describe('References', function () {
        it('collection() returns a collection by id', function () {
            var collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
            firestore.mocker.setCollection(collection);
            expect(firestore.mocker.collection('test')).toBe(collection);
        });
        it('collection() returns a collection by path', function () {
            var collection = firestore.collection(documentPath);
            var document = firestore.mocker.collection('company').doc('mindhive');
            expect(document.collection('skills/coding/technologies')).toBe(collection);
        });
    });
    describe('set()', function () {
        it('will replace the current data', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        expect(firestore.doc('test/doc')).toBe(document);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will only update defined fields if merge options set to true', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.set({
                                new: 'field',
                            }, { merge: true })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: 'data',
                            new: 'field',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will not disassemble field.paths -expressions on field names', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.set({
                                'new.field': 'field',
                            }, { merge: true })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: 'data',
                            'new.field': 'field',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will replace the current data', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        expect(firestore.doc('test/doc')).toBe(document);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will only update defined fields if merge options set to true', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.set({
                                new: 'field',
                            }, { merge: true })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: 'data',
                            new: 'field',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger onSnapshot event listeners', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, snap, listener, unsubscribe, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        listener = function (snapshot) {
                            snap = snapshot;
                        };
                        unsubscribe = document.onSnapshot(listener);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        expect(snap).toBeDefined();
                        expect(snap.exists).toBeDefined();
                        expect(snap.data()).toEqual(data);
                        unsubscribe();
                        return [2 /*return*/];
                }
            });
        }); });
        // TODO merge options
        // it('will throw unauthorized exception if write is not allowed', () => {
        //   const firestore = new MockFirebaseApp().firestore();
        //   firestore.mocker.reset();
        //   firestore.mocker.loadCollection('users', {
        //     user1: {
        //       name: 'Johnny',
        //     },
        //     user2: {
        //       name: 'Cash',
        //     },
        //   });
        //   const docRef = firestore.doc('users/user1');
        //   expect.assertions(1);
        //   expect(
        //     docRef.set({
        //       value: 'nada',
        //     })
        //   ).rejects.toMatch('PERMISSION_DENIED');
        // });
        // it('will throw unauthorized exception if create is not allowed', () => {});
        // it('will throw unauthorized exception if update is not allowed', () => {});
    });
    describe('delete()', function () {
        it('will remove the document', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        return [4 /*yield*/, document.delete()];
                    case 1:
                        _a.sent();
                        expect(collection.mocker.doc('doc')).toBeUndefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger onSnapshot -event after registering a tricker', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, snap, listener, unsubscribe;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        listener = function (snapshot) {
                            snap = snapshot;
                        };
                        unsubscribe = document.onSnapshot(listener);
                        return [4 /*yield*/, document.delete()];
                    case 1:
                        _a.sent();
                        expect(collection.mocker.doc('doc')).toBeUndefined();
                        expect(snap.data()).toBeUndefined();
                        expect(snap.exists).toBeFalsy();
                        unsubscribe();
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger onSnapshot -event', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, snap, listener, unsubscribe;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        listener = function (snapshot) {
                            snap = snapshot;
                        };
                        unsubscribe = document.onSnapshot(listener);
                        return [4 /*yield*/, document.delete()];
                    case 1:
                        _a.sent();
                        expect(collection.mocker.doc('doc')).toBeUndefined();
                        expect(snap.data()).toBeUndefined();
                        expect(snap.exists).toBeFalsy();
                        unsubscribe();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('get()', function () {
        it('will get snapshot with data', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data, snapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, document.get()];
                    case 2:
                        snapshot = _a.sent();
                        expect(snapshot.exists).toBeTruthy();
                        expect(snapshot.data()).toEqual(data);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will get snapshot with exists = false if document does not exists', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, snapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        return [4 /*yield*/, document.get()];
                    case 1:
                        snapshot = _a.sent();
                        expect(snapshot.exists).toBeFalsy();
                        expect(snapshot.data()).toBeUndefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('will read an array type data as an array object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        firestore.mocker.loadDocument('collection/doc', {
                            anArray: ['one', 'two', 'three'],
                        });
                        return [4 /*yield*/, firestore.doc('collection/doc').get()];
                    case 1:
                        result = _a.sent();
                        expect(result.exists).toBeTruthy();
                        data = result.data();
                        expect(data.anArray).toBeDefined();
                        expect(Array.isArray(data.anArray)).toBeTruthy();
                        expect(data.anArray.length).toBe(3);
                        data.anArray.push('four');
                        expect(data.anArray.length).toBe(4);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('isEqual()', function () {
        it('will identify if the document refence points to itself ', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, document2;
            return __generator(this, function (_a) {
                firestore.mocker.reset();
                collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                firestore.mocker.setCollection(collection);
                document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                collection.mocker.setDoc(document);
                document2 = new MockDocumentReference_1.default(firestore, 'doc2', collection);
                collection.mocker.setDoc(document2);
                expect(document.isEqual(document)).toBeTruthy();
                expect(document.isEqual(document2)).toBeFalsy();
                return [2 /*return*/];
            });
        }); });
    });
    describe('onSnapshot()', function () {
        // TODO no onSnapshot call when data has bot been changed
        it('will let user to start and stop listening snapshots', function () {
            firestore.mocker.reset();
            var doc = firestore.doc('test/doc');
            // tslint:disable-next-line: no-empty
            var listener = function (snapshot) { };
            var unsubscribe = doc.onSnapshot(listener);
            expect(unsubscribe).toBeDefined();
            expect(doc.mocker.listeners()).toEqual([listener]);
            unsubscribe();
            expect(doc.mocker.listeners()).toEqual([]);
        });
        it('will trigger once snapshot listener after registration', function () {
            firestore.mocker.reset();
            var doc = firestore.doc('test/doc');
            // tslint:disable-next-line: no-empty
            var triggerCount = 0;
            var listener = function (snapshot) {
                triggerCount++;
            };
            doc.onSnapshot(listener);
            expect(triggerCount).toBe(1);
        });
    });
    describe('update()', function () {
        it('will alter the data and maintain the existing data in the object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.update({
                                test2: 'more',
                            })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: 'data',
                            test2: 'more',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will fail if document do not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
            var document, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        document = firestore.doc('test/doc');
                        expect.assertions(1);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, document.update({
                                test2: 'more',
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        expect(error_1).toBeDefined();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('will alter the data with dot delimeted presentation', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.update({
                                'test2.sub': 'more',
                            })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: 'data',
                            test2: {
                                sub: 'more',
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will field value replaced with a new data with dot delimeted presentation', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collection, document, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.reset();
                        collection = new MockCollectionReference_1.MockCollectionReference(firestore, 'test', null);
                        firestore.mocker.setCollection(collection);
                        document = new MockDocumentReference_1.default(firestore, 'doc', collection);
                        collection.mocker.setDoc(document);
                        data = {
                            test: 'data',
                        };
                        return [4 /*yield*/, document.set(data)];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual(data);
                        return [4 /*yield*/, document.update({
                                'test.sub': 'more',
                            })];
                    case 2:
                        _a.sent();
                        expect(document.data).toEqual({
                            test: {
                                sub: 'more',
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will alter the data with simple key-value pair', function () { return __awaiter(void 0, void 0, void 0, function () {
            var database, document;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        database = {
                            list: {
                                docs: {
                                    doc: {
                                        data: {
                                            value: 1,
                                        },
                                    },
                                },
                            },
                        };
                        firestore.mocker.fromMockDatabase(database);
                        document = firestore.doc('list/doc');
                        return [4 /*yield*/, document.update('test', 'cool')];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual({
                            value: 1,
                            test: 'cool',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will alter the data with multiple key-value pairs', function () { return __awaiter(void 0, void 0, void 0, function () {
            var database, document;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        database = {
                            list: {
                                docs: {
                                    doc: {
                                        data: {
                                            value: 1,
                                        },
                                    },
                                },
                            },
                        };
                        firestore.mocker.fromMockDatabase(database);
                        document = firestore.doc('list/doc');
                        return [4 /*yield*/, document.update('test', 'cool', 'test2', 'cooler', 'test3', 'the coolest')];
                    case 1:
                        _a.sent();
                        expect(document.data).toEqual({
                            value: 1,
                            test: 'cool',
                            test2: 'cooler',
                            test3: 'the coolest',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    it('will alter the data with simple FieldPath', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, document;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        list: {
                            docs: {
                                doc: {
                                    data: {
                                        value: 1,
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    document = firestore.doc('list/doc');
                    return [4 /*yield*/, document.update(new MockFieldPath_1.MockFieldPath('test'), 'cool')];
                case 1:
                    _a.sent();
                    expect(document.data).toEqual({
                        value: 1,
                        test: 'cool',
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('will alter the data with FieldPath to sub object', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, document;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        list: {
                            docs: {
                                doc: {
                                    data: {
                                        value: 1,
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    document = firestore.doc('list/doc');
                    return [4 /*yield*/, document.update(new MockFieldPath_1.MockFieldPath('test', 'dive'), 'cool')];
                case 1:
                    _a.sent();
                    expect(document.data).toEqual({
                        value: 1,
                        test: {
                            dive: 'cool',
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('will alter the data with with multiple FieldPath value pairs', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, document;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        list: {
                            docs: {
                                doc: {
                                    data: {
                                        value: 1,
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    document = firestore.doc('list/doc');
                    return [4 /*yield*/, document.update(new MockFieldPath_1.MockFieldPath('test', 'dive'), 'cool')];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, document.update(new MockFieldPath_1.MockFieldPath('test', 'another'), 6)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, document.update(new MockFieldPath_1.MockFieldPath('diverse', 'paths', 'possible'), true)];
                case 3:
                    _a.sent();
                    expect(document.data).toEqual({
                        value: 1,
                        test: {
                            dive: 'cool',
                            another: 6,
                        },
                        diverse: {
                            paths: {
                                possible: true,
                            },
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('will replace field path to objects when the current field is not an object', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, document, fieldPath, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        list: {
                            docs: {
                                doc: {
                                    data: {
                                        value: 1,
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    document = firestore.doc('list/doc');
                    fieldPath = new MockFieldPath_1.MockFieldPath('value', 'sub', 'value');
                    return [4 /*yield*/, document.update(fieldPath, 'object')];
                case 1:
                    _a.sent();
                    data = document.mocker.getData();
                    expect(data).toEqual({
                        value: {
                            sub: {
                                value: 'object',
                            },
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=MockDocumentReference.spec.js.map