"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MockFieldPath_1 = require("../MockFieldPath");
describe('Field Paths', function () {
    describe('MockFieldPath', function () {
        it('will return a simple path', function () {
            var fieldPath = new MockFieldPath_1.MockFieldPath('cool');
            expect(fieldPath.path).toMatch('cool');
        });
        it('will return a path to sub field', function () {
            var fieldPath = new MockFieldPath_1.MockFieldPath('cool', 'beer', 'tempts', 'me');
            expect(fieldPath.path).toMatch('cool.beer.tempts.me');
        });
        it('will identify equal paths', function () {
            var firstPint = new MockFieldPath_1.MockFieldPath('cool', 'beer');
            var secondPint = new MockFieldPath_1.MockFieldPath('cool', 'beer');
            expect(firstPint.isEqual(secondPint)).toBeTruthy();
        });
        it('will identify inequal paths', function () {
            var firstPint = new MockFieldPath_1.MockFieldPath('cool', 'beer');
            var notSoGood = new MockFieldPath_1.MockFieldPath('warm', 'cider');
            expect(firstPint.isEqual(notSoGood)).toBeFalsy();
        });
        it('will return document id sentinel', function () {
            expect(MockFieldPath_1.MockFieldPath.documentId).toBe(MockFieldPath_1.documentIdSentinel);
        });
    });
    describe('createFieldPathFromString', function () {
        it('will transform string presentation to object', function () {
            var path = MockFieldPath_1.createFieldPathFromString('test.me.well');
            expect(path.fieldNames).toEqual(['test', 'me', 'well']);
        });
    });
});
//# sourceMappingURL=MockFieldPath.spec.js.map