"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
describe('Snapshot listeners', function () {
    describe('Triggering changed of documents in Collection References', function () {
        var testDb1 = {
            list: {
                docs: {
                    first: {
                        data: {
                            name: 'first',
                        },
                    },
                    second: {
                        data: {
                            name: 'second',
                        },
                    },
                    third: {
                        data: {
                            name: 'second',
                        },
                    },
                },
            },
        };
        it('will trigger update when document is changed', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collectionRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        collectionRef = firestore.collection('list');
                        documentRef = firestore.doc('list/first');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        collectionRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.update({
                                name: 'modified',
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(3);
                        expect(snap.docs[0].data()).toEqual({
                            name: 'modified',
                        });
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('modified');
                        expect(docChanges[0].doc).toBe(snap.docs[0]);
                        expect(docChanges[0].oldIndex).toBe(0);
                        expect(docChanges[0].newIndex).toBe(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger removed when document is deleted', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collectionRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        collectionRef = firestore.collection('list');
                        documentRef = firestore.doc('list/first');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        collectionRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.delete()];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(2);
                        expect(snap.docs[0].data()).toEqual({
                            name: 'second',
                        });
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('removed');
                        expect(docChanges[0].doc.id).toMatch('first');
                        expect(docChanges[0].oldIndex).toBe(0);
                        expect(docChanges[0].newIndex).toBe(-1);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger added when document is set by a new reference', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collectionRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        collectionRef = firestore.collection('list');
                        documentRef = firestore.doc('list/forth');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        collectionRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.set({
                                name: 'newbie',
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(4);
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('added');
                        expect(docChanges[0].doc.id).toMatch('forth');
                        expect(docChanges[0].oldIndex).toBe(-1);
                        expect(docChanges[0].newIndex).toBeGreaterThanOrEqual(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger added when document is added from CollectioReference', function () { return __awaiter(void 0, void 0, void 0, function () {
            var collectionRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        collectionRef = firestore.collection('list');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        collectionRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, collectionRef.add({
                                name: 'newbie',
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(4);
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('added');
                        expect(docChanges[0].doc.id).toBeDefined();
                        expect(docChanges[0].oldIndex).toBe(-1);
                        expect(docChanges[0].newIndex).toBeGreaterThanOrEqual(0);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Triggering changed of documents in Query References', function () {
        var testDb1 = {
            list: {
                docs: {
                    first: {
                        data: {
                            name: 'first',
                            value: 1,
                        },
                    },
                    second: {
                        data: {
                            name: 'second',
                            value: 2,
                        },
                    },
                    third: {
                        data: {
                            name: 'third',
                            value: 3,
                        },
                    },
                    fourth: {
                        data: {
                            name: 'fourth',
                            value: 4,
                        },
                    },
                },
            },
        };
        it('will trigger update when document in query is changed', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore.collection('list').where('value', '>=', 3);
                        documentRef = firestore.doc('list/fourth');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.update({
                                name: 'modified',
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(2);
                        expect(snap.docs[1].data()).toEqual({
                            name: 'modified',
                            value: 4,
                        });
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('modified');
                        // expect(docChanges[0].doc).toBe(snap!.docs[0]);
                        expect(docChanges[0].oldIndex).toBe(1);
                        expect(docChanges[0].newIndex).toBe(1);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will not trigger update when document does not match the query', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, documentRef, snap, onSnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore.collection('list').where('value', '>=', 3);
                        documentRef = firestore.doc('list/first');
                        onSnapshot = jest.fn(function (snapshot) {
                            snap = snapshot;
                        });
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.update({
                                name: 'modified',
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeUndefined();
                        expect(onSnapshot.mock.calls.length).toBe(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger an added evenet, when new document is been added in a query range', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore
                            .collection('list')
                            .where('value', '>=', 3)
                            .orderBy('value');
                        documentRef = firestore.doc('list/fifth');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.set({
                                name: 'in set',
                                value: 3.5,
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(3);
                        expect(snap.docs[1].data()).toEqual({
                            name: 'in set',
                            value: 3.5,
                        });
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('added');
                        // expect(docChanges[0].doc).toBe(snap!.docs[0]);
                        expect(docChanges[0].oldIndex).toBe(-1);
                        expect(docChanges[0].newIndex).toBe(1);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will not trigger an added event, when new document is been added outside of the query range', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, collectionRef, snap, onSnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore
                            .collection('list')
                            .where('value', '>=', 3)
                            .orderBy('value');
                        collectionRef = firestore.collection('list');
                        onSnapshot = jest.fn(function (snapshot) {
                            snap = snapshot;
                        });
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, collectionRef.add({
                                name: 'modified',
                                value: 0,
                            })];
                    case 1:
                        _a.sent();
                        expect(snap).toBeUndefined();
                        expect(onSnapshot.mock.calls.length).toBe(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will trigger an removed event, when a document is been deleted in a query range', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, documentRef, snap, onSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore
                            .collection('list')
                            .where('value', '>=', 3)
                            .orderBy('value');
                        documentRef = firestore.doc('list/third');
                        onSnapshot = function (snapshot) {
                            snap = snapshot;
                        };
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.delete()];
                    case 1:
                        _a.sent();
                        expect(snap).toBeDefined();
                        expect(snap.docs.length).toBe(1);
                        expect(snap.docs[0].data()).toEqual({
                            name: 'fourth',
                            value: 4,
                        });
                        docChanges = snap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('removed');
                        expect(docChanges[0].oldIndex).toBe(0);
                        expect(docChanges[0].newIndex).toBe(-1);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will not trigger a removed event, when deleted document is been removed outside of the query range', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, documentRef, snap, onSnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore
                            .collection('list')
                            .where('value', '>=', 3)
                            .orderBy('value');
                        documentRef = firestore.doc('list/first');
                        onSnapshot = jest.fn(function (snapshot) {
                            snap = snapshot;
                        });
                        queryRef.onSnapshot(onSnapshot);
                        return [4 /*yield*/, documentRef.delete()];
                    case 1:
                        _a.sent();
                        expect(snap).toBeUndefined();
                        expect(onSnapshot.mock.calls.length).toBe(0);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Triggering changed of documents to multiple targets', function () {
        var testDb1 = {
            list: {
                docs: {
                    first: {
                        data: {
                            name: 'first',
                            value: 1,
                        },
                    },
                    second: {
                        data: {
                            name: 'second',
                            value: 2,
                        },
                    },
                    third: {
                        data: {
                            name: 'third',
                            value: 3,
                        },
                    },
                    fourth: {
                        data: {
                            name: 'fourth',
                            value: 4,
                        },
                    },
                },
            },
        };
        it('will trigger update to multiple query listeners, when document in query is changed', function () { return __awaiter(void 0, void 0, void 0, function () {
            var queryRef, orderedQueryRef, documentRef, querySnap, onQuerySnapshot, orderedSnap, onOrderedQuerySnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(testDb1);
                        queryRef = firestore.collection('list').where('value', '>=', 3);
                        orderedQueryRef = queryRef.orderBy('value');
                        documentRef = firestore.doc('list/fourth');
                        onQuerySnapshot = jest.fn(function (snapshot) {
                            querySnap = snapshot;
                        });
                        queryRef.onSnapshot(onQuerySnapshot);
                        onOrderedQuerySnapshot = jest.fn(function (snapshot) {
                            orderedSnap = snapshot;
                        });
                        orderedQueryRef.onSnapshot(onOrderedQuerySnapshot);
                        return [4 /*yield*/, documentRef.update({
                                name: 'modified',
                            })];
                    case 1:
                        _a.sent();
                        expect(querySnap).toBeDefined();
                        expect(orderedSnap).toBeDefined();
                        expect(querySnap.docs.length).toBe(2);
                        expect(orderedSnap.docs.length).toBe(2);
                        expect(querySnap.docs[1].data()).toEqual({
                            name: 'modified',
                            value: 4,
                        });
                        expect(orderedSnap.docs[1].data()).toEqual({
                            name: 'modified',
                            value: 4,
                        });
                        docChanges = querySnap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('modified');
                        expect(docChanges[0].oldIndex).toBe(1);
                        expect(docChanges[0].newIndex).toBe(1);
                        docChanges = orderedSnap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('modified');
                        expect(docChanges[0].oldIndex).toBe(1);
                        expect(docChanges[0].newIndex).toBe(1);
                        expect(onQuerySnapshot.mock.calls.length).toBe(1);
                        expect(onOrderedQuerySnapshot.mock.calls.length).toBe(1);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=Snapshot.spec.js.map