"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var MockFieldPath_1 = require("../MockFieldPath");
var MockFieldValue_1 = require("../MockFieldValue");
var MockTimestamp_1 = require("../MockTimestamp");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
// tslint:disable-next-line: no-big-function
describe('FieldValue', function () {
    // tslint:disable-next-line: no-big-function
    describe('with object updates', function () {
        describe('Delete sentinel', function () {
            var database = {
                list: {
                    docs: {
                        a: {
                            data: {
                                first: 1,
                                second: 2,
                            },
                        },
                    },
                },
            };
            it('will delete field from data on the top level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            return [4 /*yield*/, ref.update({
                                    first: MockFieldValue_1.MockFieldValue.delete(),
                                })];
                        case 1:
                            _a.sent();
                            expect(ref.data).toEqual({
                                second: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will throw an invalid-argument error when trying to use FieldValue.delete in sub object', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref, error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            // FirebaseError: [code=invalid-argument]: Function DocumentReference.update() called with invalid data. FieldValue.delete() can only appear at the top level of your update data (found in field third.sub.B)
                            return [4 /*yield*/, ref.set({
                                    third: {
                                        sub: {
                                            A: 1,
                                            B: 2,
                                            C: 3,
                                        },
                                    },
                                }, {
                                    merge: true,
                                })];
                        case 1:
                            // FirebaseError: [code=invalid-argument]: Function DocumentReference.update() called with invalid data. FieldValue.delete() can only appear at the top level of your update data (found in field third.sub.B)
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, ref.update({
                                    third: {
                                        sub: {
                                            B: MockFieldValue_1.MockFieldValue.delete(),
                                        },
                                    },
                                })];
                        case 3:
                            _a.sent();
                            return [3 /*break*/, 5];
                        case 4:
                            error_1 = _a.sent();
                            expect(error_1.code).toBe('invalid-argument');
                            expect(error_1.message).toBe('DocumentReference.update() called with invalid data. FieldValue.delete() can only appear at the top level of your update data (found in field third.sub.B)');
                            return [3 /*break*/, 5];
                        case 5: return [2 /*return*/];
                    }
                });
            }); });
            // TODO fieldPath updates and sets with field values
        });
        describe('Timestamp sentinel', function () {
            describe('No server time defined', function () {
                // tslint:disable-next-line: no-duplicate-string
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update({
                                        first: MockFieldValue_1.MockFieldValue.serverTimestamp(),
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('Server time mocked with MockTimestamp value', function () {
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var timestamp, database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                timestamp = MockTimestamp_1.MockTimestamp.fromDate(new Date('2019-03-11 20:47'));
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.serverTime = timestamp;
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update({
                                        first: MockFieldValue_1.MockFieldValue.serverTimestamp(),
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                expect(timestamp.isEqual(ref.data.first)).toBe(true);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('Server time mocked with a function', function () {
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var timestamp, database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                timestamp = MockTimestamp_1.MockTimestamp.fromDate(new Date('2019-03-11 21:47'));
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.serverTime = function () { return timestamp; };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update({
                                        first: MockFieldValue_1.MockFieldValue.serverTimestamp(),
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                expect(timestamp.isEqual(ref.data.first)).toBe(true);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
        describe('Array sentinels', function () {
            describe('arrayUnion', function () {
                it('will add a new value to the end of an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        table: MockFieldValue_1.MockFieldValue.arrayUnion([3]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [1, 2, 3],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will add only values that does not already exist in an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        table: MockFieldValue_1.MockFieldValue.arrayUnion([2, 3, 4]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [1, 2, 3, 4],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will override fieldvalue if it is not an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    nottable: 1,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        nottable: MockFieldValue_1.MockFieldValue.arrayUnion([3, 4, 5]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    nottable: [3, 4, 5],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('arrayRemove', function () {
                it('will remove a value from an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        table: MockFieldValue_1.MockFieldValue.arrayRemove([1]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [2],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will remove all values that does exist in an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        table: MockFieldValue_1.MockFieldValue.arrayRemove([1, 2, 3, 4]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will override field value with an empty array if it is not an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    nottable: 1,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.set({
                                        nottable: MockFieldValue_1.MockFieldValue.arrayRemove([3, 4, 5]),
                                    }, {
                                        merge: true,
                                    })];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    nottable: [],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
    });
    // tslint:disable-next-line: no-big-function
    describe('with field path updates', function () {
        describe('Delete sentinel', function () {
            var database = {
                list: {
                    docs: {
                        a: {
                            data: {
                                first: 1,
                                second: 2,
                            },
                        },
                    },
                },
            };
            it('will delete field from data on the top level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            return [4 /*yield*/, ref.update('first', MockFieldValue_1.MockFieldValue.delete())];
                        case 1:
                            _a.sent();
                            expect(ref.data).toEqual({
                                second: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will delete field pointed with Field Path from data on the top level', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            return [4 /*yield*/, ref.update(new MockFieldPath_1.MockFieldPath('first'), MockFieldValue_1.MockFieldValue.delete())];
                        case 1:
                            _a.sent();
                            expect(ref.data).toEqual({
                                second: 2,
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will delete field from sub object - 2', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            return [4 /*yield*/, ref.set({
                                    third: {
                                        sub: {
                                            A: 1,
                                            B: 2,
                                            C: 3,
                                        },
                                    },
                                }, {
                                    merge: true,
                                })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, ref.update({
                                    'third.sub.B': MockFieldValue_1.MockFieldValue.delete(),
                                })];
                        case 2:
                            _a.sent();
                            expect(ref.data).toEqual({
                                first: 1,
                                second: 2,
                                third: {
                                    sub: {
                                        A: 1,
                                        C: 3,
                                    },
                                },
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            it('will delete field from sub object - 3', function () { return __awaiter(void 0, void 0, void 0, function () {
                var ref;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            firestore.mocker.fromMockDatabase(database);
                            ref = firestore.doc('list/a');
                            return [4 /*yield*/, ref.set({
                                    third: {
                                        sub: {
                                            A: 1,
                                            B: 2,
                                            C: 3,
                                        },
                                    },
                                }, {
                                    merge: true,
                                })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, ref.update(new MockFieldPath_1.MockFieldPath('third', 'sub', 'B'), MockFieldValue_1.MockFieldValue.delete())];
                        case 2:
                            _a.sent();
                            expect(ref.data).toEqual({
                                first: 1,
                                second: 2,
                                third: {
                                    sub: {
                                        A: 1,
                                        C: 3,
                                    },
                                },
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            // TODO fieldPath updates and sets with field values
        });
        describe('Timestamp sentinel', function () {
            describe('No server time defined', function () {
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('first', MockFieldValue_1.MockFieldValue.serverTimestamp())];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('Server time mocked with MockTimestamp value', function () {
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var timestamp, database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                timestamp = MockTimestamp_1.MockTimestamp.fromDate(new Date('2019-03-11 20:47'));
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.serverTime = timestamp;
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('first', MockFieldValue_1.MockFieldValue.serverTimestamp())];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                expect(timestamp.isEqual(ref.data.first)).toBe(true);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('Server time mocked with a function', function () {
                it('will replace sentinels with timestamps', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var timestamp, database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                timestamp = MockTimestamp_1.MockTimestamp.fromDate(new Date('2019-03-11 21:47'));
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    first: 1,
                                                    second: 2,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.serverTime = function () { return timestamp; };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('first', MockFieldValue_1.MockFieldValue.serverTimestamp())];
                            case 1:
                                _a.sent();
                                expect(ref.data.first instanceof MockTimestamp_1.MockTimestamp).toBeTruthy();
                                expect(timestamp.isEqual(ref.data.first)).toBe(true);
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
        describe('Array sentinels', function () {
            describe('arrayUnion', function () {
                it('will add a new value to the end of an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('table', MockFieldValue_1.MockFieldValue.arrayUnion([3]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [1, 2, 3],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will add only values that does not already exist in an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update(new MockFieldPath_1.MockFieldPath('table'), MockFieldValue_1.MockFieldValue.arrayUnion([2, 3, 4]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [1, 2, 3, 4],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will override fieldvalue if it is not an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    nottable: 1,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('nottable', MockFieldValue_1.MockFieldValue.arrayUnion([3, 4, 5]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    nottable: [3, 4, 5],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
            describe('arrayRemove', function () {
                it('will remove a value from an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('table', MockFieldValue_1.MockFieldValue.arrayRemove([1]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [2],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will remove all values that does exist in an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    table: [1, 2],
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('table', MockFieldValue_1.MockFieldValue.arrayRemove([1, 2, 3, 4]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    table: [],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
                it('will override field value with an empty array if it is not an array', function () { return __awaiter(void 0, void 0, void 0, function () {
                    var database, ref;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                database = {
                                    list: {
                                        docs: {
                                            a: {
                                                data: {
                                                    nottable: 1,
                                                },
                                            },
                                        },
                                    },
                                };
                                firestore.mocker.fromMockDatabase(database);
                                ref = firestore.doc('list/a');
                                return [4 /*yield*/, ref.update('nottable', MockFieldValue_1.MockFieldValue.arrayRemove([3, 4, 5]))];
                            case 1:
                                _a.sent();
                                expect(ref.data).toEqual({
                                    nottable: [],
                                });
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
    });
    describe('isEqual', function () {
        it('will match two delete sentinels', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.delete();
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.delete())).toBe(true);
        });
        it('will match two timestamp sentinels', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.serverTimestamp();
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.serverTimestamp())).toBe(true);
        });
        it('will not match when matching sentinels of different type', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.serverTimestamp();
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.delete())).toBe(false);
        });
        it('will match identical arrayUnions', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayUnion([1, 2, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayUnion([1, 2, 3]))).toBe(true);
        });
        it('will not match unidentical arrayUnions', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayUnion([1, 2, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayUnion([1, 4, 3]))).toBe(false);
        });
        it('will not match arrayUnions of different length', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayUnion([1, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayUnion([1, 4, 3]))).toBe(false);
        });
        it('will match identical arrayRemoves', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayRemove([1, 2, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayRemove([1, 2, 3]))).toBe(true);
        });
        it('will not match unidentical arrayRemoves', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayRemove([1, 2, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayRemove([1, 4, 3]))).toBe(false);
        });
        it('will not match arrayRemoves of different length', function () {
            var sentinel = MockFieldValue_1.MockFieldValue.arrayRemove([1, 3]);
            expect(sentinel.isEqual(MockFieldValue_1.MockFieldValue.arrayRemove([1, 4, 3]))).toBe(false);
        });
    });
});
//# sourceMappingURL=fieldValueOperations.spec.js.map