"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var MockFieldPath_1 = require("../MockFieldPath");
var MockFieldValue_1 = require("../MockFieldValue");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
// tslint:disable-next-line: no-big-function
describe('Transaction handling', function () {
    describe('Handling multiple operations as a single transaction', function () {
        var database = {
            a: {
                docs: {
                    first: {
                        data: {
                            value: 2,
                        },
                    },
                },
            },
            b: {
                docs: {
                    A: {
                        data: {
                            text: 'A',
                        },
                    },
                    B: {
                        data: {
                            text: 'B',
                        },
                    },
                },
            },
        };
        it('will update operations atomically', function () { return __awaiter(void 0, void 0, void 0, function () {
            var ref2Snap, ref2CollectionSnap, onRef2DocumentSnapshot, onRef2CollectionSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        firestore.mocker.fromMockDatabase(database);
                        onRef2DocumentSnapshot = jest.fn(function (snapshot) {
                            ref2Snap = snapshot;
                        });
                        onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                            ref2CollectionSnap = snapshot;
                        });
                        firestore.doc('b/A').onSnapshot(onRef2DocumentSnapshot);
                        firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var ref, ref2;
                                return __generator(this, function (_a) {
                                    ref = firestore.doc('a/first');
                                    ref2 = firestore.doc('b/A');
                                    transaction.update(ref, { test: 'modified' });
                                    transaction.update(ref2, { text: 'altered' });
                                    transaction.update(ref2, { value: 3 });
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        expect(ref2CollectionSnap).toBeDefined();
                        docChanges = ref2CollectionSnap.docChanges();
                        expect(docChanges.length).toBe(1);
                        expect(docChanges[0].type).toMatch('modified');
                        expect(ref2Snap).toBeDefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('will add and update operations atomically', function () { return __awaiter(void 0, void 0, void 0, function () {
            var ref2Snap, ref2CollectionSnap, onRef2DocumentSnapshot, onRef2CollectionSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(true).toBeTruthy();
                        firestore.mocker.fromMockDatabase(database);
                        onRef2DocumentSnapshot = jest.fn(function (snapshot) {
                            ref2Snap = snapshot;
                        });
                        onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                            ref2CollectionSnap = snapshot;
                        });
                        firestore.doc('b/A').onSnapshot(onRef2DocumentSnapshot);
                        firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var ref, ref2, ref3;
                                return __generator(this, function (_a) {
                                    ref = firestore.doc('a/first');
                                    ref2 = firestore.doc('b/A');
                                    ref3 = firestore.doc('b/C');
                                    transaction.update(ref, { test: 'modified' });
                                    transaction.set(ref2, { modified: 'field' }, { merge: true });
                                    transaction.set(ref3, {
                                        text: 'added',
                                        value: 3,
                                    });
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        expect(ref2CollectionSnap).toBeDefined();
                        docChanges = ref2CollectionSnap.docChanges();
                        expect(docChanges.length).toBe(2);
                        expect(docChanges[0].type).toMatch('modified');
                        expect(docChanges[1].type).toMatch('added');
                        expect(ref2Snap).toBeDefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('will add, update and delete operations atomically', function () { return __awaiter(void 0, void 0, void 0, function () {
            var ref2CollectionSnap, onRef2CollectionSnapshot, docChanges;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(true).toBeTruthy();
                        firestore.mocker.fromMockDatabase(database);
                        onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                            ref2CollectionSnap = snapshot;
                        });
                        firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var ref, ref2, ref3;
                                return __generator(this, function (_a) {
                                    ref = firestore.doc('a/first');
                                    ref2 = firestore.doc('b/A');
                                    ref3 = firestore.doc('b/C');
                                    transaction.update(ref, { test: 'modified' });
                                    transaction.delete(ref2);
                                    transaction.set(ref3, {
                                        text: 'added',
                                        value: 3,
                                    });
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        expect(ref2CollectionSnap).toBeDefined();
                        docChanges = ref2CollectionSnap.docChanges();
                        expect(docChanges.length).toBe(2);
                        expect(docChanges[0].type).toMatch('removed');
                        expect(docChanges[1].type).toMatch('added');
                        expect(onRef2CollectionSnapshot.mock.calls.length).toBe(2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('will get value from document ref if value is not defined in transaction', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(true).toBeTruthy();
                        firestore.mocker.fromMockDatabase(database);
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var ref;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            ref = firestore.doc('b/A');
                                            return [4 /*yield*/, transaction.get(ref)];
                                        case 1:
                                            result = _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        expect(result.data()).toEqual({
                            text: 'A',
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        it('will give an error if get is called after updating operations', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(true).toBeTruthy();
                        firestore.mocker.fromMockDatabase(database);
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var ref;
                                return __generator(this, function (_a) {
                                    ref = firestore.doc('b/A');
                                    transaction.set(ref, { test: 'value' });
                                    expect(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                                        return [2 /*return*/, transaction.get(ref)];
                                    }); }); }).toThrow();
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Update operation variations', function () {
        it('Will update field defined by FieldPath', function () { return __awaiter(void 0, void 0, void 0, function () {
            var database, ref, doc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        database = {
                            a: {
                                docs: {
                                    first: {
                                        data: {
                                            sub: {
                                                value: 2,
                                            },
                                        },
                                    },
                                },
                            },
                        };
                        firestore.mocker.fromMockDatabase(database);
                        ref = firestore.doc('a/first');
                        return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                                var fieldPath;
                                return __generator(this, function (_a) {
                                    fieldPath = new MockFieldPath_1.MockFieldPath('sub', 'value');
                                    transaction.update(ref, fieldPath, 'modified');
                                    return [2 /*return*/];
                                });
                            }); })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, ref.get()];
                    case 2:
                        doc = _a.sent();
                        expect(doc.data()).toEqual({
                            sub: {
                                value: 'modified',
                            },
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    });
    it('Will update multiple fields defined in arguments with string and FieldPath pointings.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub: {
                                            value: 2,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            var fieldPath;
                            return __generator(this, function (_a) {
                                fieldPath = new MockFieldPath_1.MockFieldPath('sub', 'value');
                                transaction.update(ref, fieldPath, 'modified', 'text', 'cat');
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, ref.get()];
                case 2:
                    doc = _a.sent();
                    expect(doc.data()).toEqual({
                        sub: {
                            value: 'modified',
                        },
                        text: 'cat',
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('Will update multiple fields defined in arguments with string and FieldPath pointings.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub: {
                                            value: 2,
                                            other: 3,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                transaction.update(ref, 'sub.value', 'modified', 'text', 'cat', 'other.sub', 'category');
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    data = ref.mocker.getData();
                    expect(data).toEqual({
                        sub: {
                            value: 'modified',
                            other: 3,
                        },
                        other: {
                            sub: 'category',
                        },
                        text: 'cat',
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('Will update multiple fields defined in object with string and FieldPath pointings.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub: {
                                            value: 2,
                                            other: 3,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                transaction.update(ref, {
                                    'sub.value': 'modified',
                                    text: 'cat',
                                    'other.sub': 'category',
                                });
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    data = ref.mocker.getData();
                    expect(data).toEqual({
                        sub: {
                            value: 'modified',
                            other: 3,
                        },
                        other: {
                            sub: 'category',
                        },
                        text: 'cat',
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('Will delete fields defined with FieldValues.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub1: {
                                            value: 1,
                                        },
                                        sub2: {
                                            value: 2,
                                        },
                                        sub3: {
                                            value: 3,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                transaction.update(ref, {
                                    sub1: MockFieldValue_1.MockFieldValue.delete(),
                                });
                                transaction.update(ref, {
                                    sub2: MockFieldValue_1.MockFieldValue.delete(),
                                });
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, ref.get()];
                case 2:
                    doc = _a.sent();
                    expect(doc.data()).toEqual({
                        sub3: {
                            value: 3,
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('Will delete fields in separate operations targeting a same document.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub1: {
                                            value1: 1,
                                            value2: 2,
                                            value3: 3,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                transaction.update(ref, {
                                    'sub1.value1': MockFieldValue_1.MockFieldValue.delete(),
                                });
                                transaction.update(ref, {
                                    'sub1.value2': MockFieldValue_1.MockFieldValue.delete(),
                                });
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, ref.get()];
                case 2:
                    doc = _a.sent();
                    expect(doc.data()).toEqual({
                        sub1: {
                            value3: 3,
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('Will delete multiple fields from same document inside a transaction.', function () { return __awaiter(void 0, void 0, void 0, function () {
        var database, ref, doc;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    database = {
                        a: {
                            docs: {
                                first: {
                                    data: {
                                        sub1: {
                                            value1: 1,
                                            value2: 2,
                                            value3: 3,
                                        },
                                    },
                                },
                            },
                        },
                    };
                    firestore.mocker.fromMockDatabase(database);
                    ref = firestore.doc('a/first');
                    return [4 /*yield*/, firestore.runTransaction(function (transaction) { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                transaction.update(ref, {
                                    'sub1.value1': MockFieldValue_1.MockFieldValue.delete(),
                                    'sub1.value2': MockFieldValue_1.MockFieldValue.delete(),
                                });
                                return [2 /*return*/];
                            });
                        }); })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, ref.get()];
                case 2:
                    doc = _a.sent();
                    expect(doc.data()).toEqual({
                        sub1: {
                            value3: 3,
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
// TODO oldIndex, newIndex
/*
 * TODO The transaction read a document that was modified outside of the transaction. In this case, the transaction automatically runs again. The transaction is retried a finite number of times.
 * TODO The transaction exceeded the maximum request size of 10 MiB.
 */
//# sourceMappingURL=transactions.spec.js.map