"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var firebase = app_1.createFirebaseNamespace();
var firestore = firebase.initializeApp({}).firestore();
describe('Write batch functionality', function () {
    var database = {
        a: {
            docs: {
                first: {
                    data: {
                        value: 2,
                    },
                },
            },
        },
        b: {
            docs: {
                A: {
                    data: {
                        text: 'A',
                    },
                },
                B: {
                    data: {
                        text: 'B',
                    },
                },
            },
        },
    };
    it('will update changes in a batch', function () { return __awaiter(void 0, void 0, void 0, function () {
        var ref2Snap, ref2CollectionSnap, onRef2DocumentSnapshot, onRef2CollectionSnapshot, batch, ref, ref2, docChanges;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    firestore.mocker.fromMockDatabase(database);
                    onRef2DocumentSnapshot = jest.fn(function (snapshot) {
                        ref2Snap = snapshot;
                    });
                    onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                        ref2CollectionSnap = snapshot;
                    });
                    firestore.doc('b/A').onSnapshot(onRef2DocumentSnapshot);
                    firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                    batch = firestore.batch();
                    ref = firestore.doc('a/first');
                    ref2 = firestore.doc('b/A');
                    batch.update(ref, { test: 'modified' });
                    batch.update(ref2, { text: 'altered' });
                    batch.update(ref2, { value: 3 });
                    return [4 /*yield*/, batch.commit()];
                case 1:
                    _a.sent();
                    expect(ref2CollectionSnap).toBeDefined();
                    docChanges = ref2CollectionSnap.docChanges();
                    expect(docChanges.length).toBe(1);
                    expect(docChanges[0].type).toMatch('modified');
                    expect(ref2Snap).toBeDefined();
                    return [2 /*return*/];
            }
        });
    }); });
    it('will add and update operations atomically', function () { return __awaiter(void 0, void 0, void 0, function () {
        var ref2Snap, ref2CollectionSnap, onRef2DocumentSnapshot, onRef2CollectionSnapshot, batch, ref, ref2, ref3, docChanges;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    firestore.mocker.fromMockDatabase(database);
                    onRef2DocumentSnapshot = jest.fn(function (snapshot) {
                        ref2Snap = snapshot;
                    });
                    onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                        ref2CollectionSnap = snapshot;
                    });
                    firestore.doc('b/A').onSnapshot(onRef2DocumentSnapshot);
                    firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                    batch = firestore.batch();
                    ref = firestore.doc('a/first');
                    ref2 = firestore.doc('b/A');
                    ref3 = firestore.doc('b/C');
                    batch.update(ref, { test: 'modified' });
                    batch.set(ref2, { modified: 'field' }, { merge: true });
                    batch.set(ref3, {
                        text: 'added',
                        value: 3,
                    });
                    return [4 /*yield*/, batch.commit()];
                case 1:
                    _a.sent();
                    expect(ref2CollectionSnap).toBeDefined();
                    docChanges = ref2CollectionSnap.docChanges();
                    expect(docChanges.length).toBe(2);
                    expect(docChanges[0].type).toMatch('modified');
                    expect(docChanges[1].type).toMatch('added');
                    expect(ref2Snap).toBeDefined();
                    return [2 /*return*/];
            }
        });
    }); });
    it('will add, update and delete operations atomically', function () { return __awaiter(void 0, void 0, void 0, function () {
        var ref2CollectionSnap, onRef2CollectionSnapshot, batch, ref, ref2, ref3, docChanges;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    firestore.mocker.fromMockDatabase(database);
                    onRef2CollectionSnapshot = jest.fn(function (snapshot) {
                        ref2CollectionSnap = snapshot;
                    });
                    firestore.collection('b').onSnapshot(onRef2CollectionSnapshot);
                    batch = firestore.batch();
                    ref = firestore.doc('a/first');
                    ref2 = firestore.doc('b/A');
                    ref3 = firestore.doc('b/C');
                    batch.update(ref, { test: 'modified' });
                    batch.delete(ref2);
                    batch.set(ref3, {
                        text: 'added',
                        value: 3,
                    });
                    return [4 /*yield*/, batch.commit()];
                case 1:
                    _a.sent();
                    expect(ref2CollectionSnap).toBeDefined();
                    docChanges = ref2CollectionSnap.docChanges();
                    expect(docChanges.length).toBe(2);
                    expect(docChanges[0].type).toMatch('removed');
                    expect(docChanges[1].type).toMatch('added');
                    expect(onRef2CollectionSnapshot.mock.calls.length).toBe(2);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=writebatch.spec.js.map