"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = require("../../app");
var MockBlob_1 = require("../MockBlob");
var MockCollectionReference_1 = require("../MockCollectionReference");
var MockDocumentReference_1 = require("../MockDocumentReference");
var MockDocumentSnapshot_1 = require("../MockDocumentSnapshot");
var MockFieldPath_1 = require("../MockFieldPath");
var MockFieldValue_1 = require("../MockFieldValue");
var MockGeoPoint_1 = require("../MockGeoPoint");
var MockQuery_1 = require("../MockQuery");
var MockQueryDocumentSnapshot_1 = require("../MockQueryDocumentSnapshot");
var MockQuerySnapshot_1 = require("../MockQuerySnapshot");
var MockTimestamp_1 = require("../MockTimestamp");
var MockTransaction_1 = require("../MockTransaction");
var MockWritebatch_1 = require("../MockWritebatch");
var manipulation_1 = require("../utils/manipulation");
var firestoreNamespace = {
    Firestore: app_1.MockFirebaseFirestoreImpl,
    GeoPoint: MockGeoPoint_1.MockGeoPoint,
    Timestamp: MockTimestamp_1.MockTimestamp,
    Blob: MockBlob_1.MockBlob,
    Transaction: MockTransaction_1.default,
    WriteBatch: MockWritebatch_1.MockWriteBatch,
    DocumentReference: MockDocumentReference_1.default,
    DocumentSnapshot: MockDocumentSnapshot_1.default,
    Query: MockQuery_1.default,
    QueryDocumentSnapshot: MockQueryDocumentSnapshot_1.default,
    QuerySnapshot: MockQuerySnapshot_1.default,
    CollectionReference: MockCollectionReference_1.MockCollectionReference,
    FieldPath: MockFieldPath_1.MockFieldPath,
    FieldValue: MockFieldValue_1.MockFieldValue,
};
/**
 * Configures Firestore as part of the Firebase SDK by calling registerService.
 */
function configureForFirebase(firebase) {
    firebase.INTERNAL.registerService('firestore', function (app) { return new app_1.MockFirebaseFirestoreImpl(app); }, manipulation_1.shallowCopy(firestoreNamespace));
}
exports.configureForFirebase = configureForFirebase;
/**
 * Exports the Firestore namespace into the provided `exportObject` object under
 * the key 'firestore'. This is used for wrapped binary that exposes Firestore
 * as a goog module.
 */
function configureForStandalone(exportObject) {
    var copiedNamespace = manipulation_1.shallowCopy(firestoreNamespace);
    // Unlike the use with Firebase, the standalone allows the use of the
    // constructor, so export it's internal class
    copiedNamespace.Firestore = app_1.MockFirebaseFirestoreImpl;
    exportObject.firestore = copiedNamespace;
}
exports.configureForStandalone = configureForStandalone;
//# sourceMappingURL=index.js.map