"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var firebase_rules_parser_1 = require("firebase-rules-parser");
var fs = require("fs");
var stringUtils_1 = require("../utils/stringUtils");
var MockCollectionReference_1 = require("./MockCollectionReference");
var MockDocumentReference_1 = require("./MockDocumentReference");
var MockTransaction_1 = require("./MockTransaction");
var MockWritebatch_1 = require("./MockWritebatch");
var utils_1 = require("./utils");
var NotImplementedYet_1 = require("./utils/NotImplementedYet");
/**
 * `Firestore` represents a Firestore Database and is the entry point for all
 * Firestore operations.
 */
var MockFirebaseFirestoreImpl = /** @class */ (function () {
    // tslint:disable-next-line: cognitive-complexity
    function MockFirebaseFirestoreImpl(app) {
        var _this = this;
        this.root = new MockDocumentReference_1.default(this, '', null);
        this.readSettings = function () {
            return _this._settings;
        };
        /**
         * Specifies custom settings to be used to configure the `Firestore`
         * instance. Must be set before invoking any other methods.
         *
         * @param settings The settings to use.
         */
        this.settings = function (settings) {
            _this._settings = settings;
        };
        /**
         * Attempts to enable persistent storage, if possible.
         *
         * Must be called before any other methods (other than settings()).
         *
         * If this fails, enablePersistence() will reject the promise it returns.
         * Note that even after this failure, the firestore instance will remain
         * usable, however offline persistence will be disabled.
         *
         * There are several reasons why this can fail, which can be identified by
         * the `code` on the error.
         *
         *   * failed-precondition: The app is already open in another browser tab.
         *   * unimplemented: The browser is incompatible with the offline
         *     persistence implementation.
         *
         * @param settings Optional settings object to configure persistence.
         * @return A promise that represents successfully enabling persistent
         * storage.
         */
        this.enablePersistence = function (settings) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new NotImplementedYet_1.NotImplementedYet('MockFirebaseFirestore.enablePersistence');
            });
        }); };
        /**
         * Gets a `CollectionReference` instance that refers to the collection at
         * the specified path.
         *
         * @param collectionPath A slash-separated path to a collection.
         * @return The `CollectionReference` instance.
         */
        this.collection = function (collectionPath) {
            return utils_1.resolveReference(_this, _this.root, true, collectionPath);
        };
        this.collectionGroup = function (collectionId) {
            throw new NotImplementedYet_1.NotImplementedYet("MockFirebaseFirestore.collectionGroup");
        };
        /**
         * Gets a `DocumentReference` instance that refers to the document at the
         * specified path.
         *
         * @param documentPath A slash-separated path to a document.
         * @return The `DocumentReference` instance.
         */
        this.doc = function (documentPath) {
            return utils_1.resolveReference(_this, _this.root, false, documentPath);
        };
        /**
         * Executes the given updateFunction and then attempts to commit the
         * changes applied within the transaction. If any document read within the
         * transaction has changed, the updateFunction will be retried. If it fails
         * to commit after 5 attempts, the transaction will fail.
         *
         * @param updateFunction The function to execute within the transaction
         * context.
         * @return If the transaction completed successfully or was explicitly
         * aborted (by the updateFunction returning a failed Promise), the Promise
         * returned by the updateFunction will be returned here. Else if the
         * transaction failed, a rejected Promise with the corresponding failure
         * error will be returned.
         */
        this.runTransaction = function (updateFunction) { return __awaiter(_this, void 0, void 0, function () {
            var transaction, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        transaction = new MockTransaction_1.default(this);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, updateFunction(transaction)];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, transaction.commit()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, result];
                    case 4:
                        error_1 = _a.sent();
                        transaction.rollback();
                        return [2 /*return*/, error_1];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        /**
         * Creates a write batch, used for performing multiple writes as a single
         * atomic operation.
         */
        this.batch = function () {
            return new MockWritebatch_1.MockWriteBatch(_this);
        };
        /**
         * Re-enables use of the network for this Firestore instance after a prior
         * call to disableNetwork().
         *
         * @return A promise that is resolved once the network has been enabled.
         */
        this.enableNetwork = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new NotImplementedYet_1.NotImplementedYet('MockFirebaseFirestore.enableNetwork');
            });
        }); };
        /**
         * Disables network usage for this instance. It can be re-enabled via
         * enableNetwork(). While the network is disabled, any snapshot listeners or
         * get() calls will return results from cache, and any write operations will
         * be queued until the network is restored.
         *
         * @return A promise that is resolved once the network has been disabled.
         */
        this.disableNetwork = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new NotImplementedYet_1.NotImplementedYet('MockFirebaseFirestore.disableNetwork');
            });
        }); };
        this.existCall = function (path) {
            return false;
        };
        this.onGetCall = function (path) {
            return {};
        };
        this.clearPersistence = function () {
            throw new NotImplementedYet_1.NotImplementedYet("MockFirebaseFirestore.clearPersistence");
        };
        this.waitForPendingWrites = function () {
            throw new NotImplementedYet_1.NotImplementedYet("MockFirebaseFirestore.clearPersistence");
        };
        this.onSnapshotsInSync = function (observerOrOnSync) {
            throw new NotImplementedYet_1.NotImplementedYet("MockFirebaseFirestore.clearPersistence");
        };
        this.terminate = function () {
            throw new NotImplementedYet_1.NotImplementedYet("MockFirebaseFirestore.clearPersistence");
        };
        this.app = app;
        this.INTERNAL = {
        // delete: () => void
        };
        var firestore = this;
        var me = this;
        // TODO Refactor to own internal class
        this.mocker = {
            serverTime: undefined,
            root: function () { return me.root; },
            fromMockDatabase: function (database) {
                me.root.mocker.reset();
                for (var collectionId in database) {
                    if (database.hasOwnProperty(collectionId)) {
                        var collectionData = database[collectionId];
                        var collection = new MockCollectionReference_1.MockCollectionReference(me, collectionId, me.root);
                        me.root.mocker.setCollection(collection);
                        collection.mocker.load(collectionData);
                    }
                }
            },
            toMockDatabase: function () {
                return me.root.mocker.saveCollections();
            },
            fromJson: function (json) {
                me.mocker.fromMockDatabase(JSON.parse(json));
            },
            toJson: function () {
                return JSON.stringify(me.mocker.toMockDatabase(), undefined, 2);
            },
            reset: function () {
                me.root.mocker.reset();
                me._rules = undefined;
                me._rulesHash = undefined;
            },
            collection: function (id) {
                return me.root.mocker.collection(id);
            },
            setCollection: function (collection) {
                me.root.mocker.setCollection(collection);
            },
            loadCollection: function (collectionPath, collectionData) {
                if (!utils_1.isValidCollectionReference(collectionPath)) {
                    throw new Error("Invalid collection reference: " + collectionPath);
                }
                var collection = me.root.collection(collectionPath);
                for (var docId in collectionData) {
                    if (collectionData.hasOwnProperty(docId)) {
                        var doc = new MockDocumentReference_1.default(firestore, docId, collection);
                        doc.mocker.setData(collectionData[docId]);
                        collection.mocker.setDoc(doc);
                    }
                }
            },
            loadDocument: function (documentPath, data) {
                if (!utils_1.isValidDocumentReference(documentPath)) {
                    throw new Error("Invalid document reference: " + documentPath);
                }
                var index = documentPath.indexOf('/');
                var rootCollection = documentPath.substring(0, index);
                var path = documentPath.substring(index + 1);
                var doc = me.root.collection(rootCollection).doc(path);
                doc.mocker.setData(data);
            },
            loadRulesFromString: function (sourceFile) {
                var hashValue = stringUtils_1.hash(sourceFile);
                // avoid parsing if the file is already loaded
                if (hashValue !== me._rulesHash) {
                    me._rules = firebase_rules_parser_1.default();
                    me._rules.init(sourceFile);
                    me._rulesHash = hashValue;
                }
            },
            loadRulesFromFile: function (filePath) {
                var path = filePath || require('app-root-path') + 'firebase.rules';
                var sourceCode = fs.readFileSync(path, 'utf-8');
                me.mocker.loadRulesFromString(sourceCode);
            },
            rules: function () {
                return me.rules;
            },
            getRulesContext: function (resource) {
                var context = firebase_rules_parser_1.defaultFirebaseRulesContext;
                context.resource = resource;
                context.auth = {}; // TODO fix auth
                context.onExistsCall = me.existCall;
                context.onGetCall = me.onGetCall;
                return context;
            },
            setNextDocumentIds: function (ids) {
                if (Array.isArray(ids)) {
                    me._nextDocumentIdsArray = ids;
                    me._nextDocumentIdsFun = undefined;
                    return;
                }
                if (typeof ids === 'function') {
                    me._nextDocumentIdsArray = undefined;
                    me._nextDocumentIdsFun = ids;
                    return;
                }
                throw new Error('Illegal argument type of ' + typeof ids);
            },
            getNextDocumentId: function (collectionPath) {
                if (me._nextDocumentIdsArray && me._nextDocumentIdsArray.length > 0) {
                    return me._nextDocumentIdsArray.shift();
                }
                if (me._nextDocumentIdsFun) {
                    return me._nextDocumentIdsFun(collectionPath);
                }
                return utils_1.generateDocumentId();
            },
        };
    }
    Object.defineProperty(MockFirebaseFirestoreImpl.prototype, "rules", {
        get: function () {
            return this._rules;
        },
        enumerable: true,
        configurable: true
    });
    return MockFirebaseFirestoreImpl;
}());
exports.MockFirebaseFirestoreImpl = MockFirebaseFirestoreImpl;
var MockFieldPath_1 = require("./MockFieldPath");
exports.MockFieldPath = MockFieldPath_1.MockFieldPath;
var MockFieldValue_1 = require("./MockFieldValue");
exports.MockFieldValue = MockFieldValue_1.MockFieldValue;
var MockGeoPoint_1 = require("./MockGeoPoint");
exports.MockGeoPoint = MockGeoPoint_1.MockGeoPoint;
var MockTimestamp_1 = require("./MockTimestamp");
exports.MockTimestamp = MockTimestamp_1.MockTimestamp;
var MockBlob_1 = require("./MockBlob");
exports.MockBlob = MockBlob_1.MockBlob;
__export(require("./utils/mocker"));
//# sourceMappingURL=index.js.map