import { DocumentData } from '@firebase/firestore-types';
/**
 * Callback handler used for basic operation in onSnapshot -handlers.
 *
 * @export
 * @class MockListener
 * @template S Type of snapshot object
 */
export default class MockCallbackHandler<S = DocumentData> {
    private _callbacks;
    /**
     * Add a new snapshot callback
     * @param {<S>(snapshot: S) => void} callback callback function
     */
    add: (callback: (snapshot: S) => void) => void;
    remove: (callback: (snapshot: S) => void) => void;
    fire: (snapshot: S, callbacks?: ((snapshot: S) => void)[]) => void;
    get list(): Array<(snapshot: S) => void>;
    load: (callbacks: ((snapshot: S) => void)[]) => void;
    reset: () => void;
}
