import { FirestoreError, FirestoreErrorCode } from '@firebase/firestore-types';
export declare class MockFirestoreError extends Error implements FirestoreError {
    code: FirestoreErrorCode;
    message: string;
    name: string;
    stack?: string;
    /**
     * Creates an instance of MockFirestoreError.
     *
     * @param {FirestoreErrorCode} code Firestore's error code
     * @param {string} message A human readable error message to be included with error
     * @memberof MockFirestoreError
     */
    constructor(code: FirestoreErrorCode, message: string);
}
