"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MockFirestoreError_1 = require("../MockFirestoreError");
var NotImplementedYet_1 = require("../NotImplementedYet");
describe('Errors', function () {
    describe('MockFirestoreError', function () {
        it('will create an error with given error code and message', function () {
            var error = new MockFirestoreError_1.MockFirestoreError('internal', 'test');
            expect(error.code).toBe('internal');
            expect(error.message).toBe('test');
        });
    });
    describe('NotImplementedYet', function () {
        it('will create an error with message including given label', function () {
            var error = new NotImplementedYet_1.NotImplementedYet('jest');
            expect(error.message).toMatch('jest');
        });
        it('will create an error with message including "Not implemented yet" -text', function () {
            var error = new NotImplementedYet_1.NotImplementedYet('jest');
            expect(error.message).toMatch('Not implemented yet');
        });
        it('will not require label to used', function () {
            var error = new NotImplementedYet_1.NotImplementedYet();
            expect(error.message).toMatch('Not implemented yet');
        });
    });
});
//# sourceMappingURL=errors.spec.js.map