import { MockDocument, MockCollection, MockCollections, MockDocuments } from './../index';
import { MockDocumentSnapshotCallback } from './../MockDocumentReference';
import { DocumentData } from '@firebase/firestore-types';
/**
 * Helper function to define a document with typings in mock database
 * @param content Mock document's data
 */
export declare const _d: <T = DocumentData>(content: {
    data?: T | undefined;
    collections?: MockCollections<T> | undefined;
    listerners?: MockDocumentSnapshotCallback[] | undefined;
}) => MockDocument<T>;
/**
 * Helper function to define a collection with typings in mock database
 * @param content Mock collections's data
 */
export declare const _c: <T = DocumentData>(content: {
    docs?: MockDocuments<T> | undefined;
    listeners?: any[] | undefined;
}) => MockCollection<T>;
export declare const _o: <T = DocumentData>(data: T) => T;
interface StringMap<T> {
    [key: string]: T;
}
export declare const _m: <T = DocumentData>(data: StringMap<T>) => StringMap<T>;
export {};
